# MMTests Tutorials

## Get MMTests

Clone MMTests from GitHub:

```
sudo zypper in git
git clone https://github.com/gormanm/mmtests.git
```

## Your First MMTests Runs

### Baseline Run

Pick a config and start a run. For instance, let's run a Redis benchmark.

```
sudo ./run-mmtests.sh --config configs/config-memdb-redis-small BASELINE
```

### Comparison Run

We now need at least another run, so we can compare. Just to introduce some
variation, let's add some disturbing tasks.

```
for i in `seq 1 8`; do yes &> /dev/null & done
sudo ./run-mmtests.sh --config configs/config-memdb-redis-small BUSY
```

### Results

Now, this is how the results directory looks like:

```
ls work/log/
BASELINE  BUSY

ls work/log/BASELINE/iter-0/ -l
total 272
-rw-r--r-- 1 root root 13773 Jun 16 04:30 cgroup-tree.txt.gz
-rw-r--r-- 1 root root   294 Jun 16 04:30 cpupower.txt.gz
-rw-r--r-- 1 root root   129 Jun 16 04:30 cpu-topology-mmtests.txt.gz
-rw-r--r-- 1 root root   911 Jun 16 04:30 cpu-vulnerabilities.txt
-rw-r--r-- 1 root root     0 Jun 16 04:30 cstate-latencies-BASELINE.txt
-rw-r--r-- 1 root root 15951 Jun 16 04:46 dmesg.gz
-rw-r--r-- 1 root root 13869 Jun 16 04:46 journalctl-kernel.gz
-rw-r--r-- 1 root root 60085 Jun 16 04:30 kconfig-5.12.9-1-default.txt.gz
-rw-r--r-- 1 root root  2342 Jun 16 04:30 kernel-tuning.txt.gz
-rw-r--r-- 1 root root   121 Jun 16 04:30 kernel.version
-rw-r--r-- 1 root root  1097 Jun 16 04:30 lscpu.txt.gz
-rw-r--r-- 1 root root    80 Jun 16 04:30 lsscsi.txt.gz
-rw-r--r-- 1 root root  6346 Jun 16 04:30 lstopo.pdf.gz
-rw-r--r-- 1 root root   829 Jun 16 04:30 lstopo.txt.gz
-rw-r--r-- 1 root root  5030 Jun 16 04:30 network-tuning.txt.gz
-rw-r--r-- 1 root root   126 Jun 16 04:30 numactl.txt.gz
-rw-r--r-- 1 root root 16526 Jun 16 04:46 proc-vmstat-redis.gz
-rw-r--r-- 1 root root    26 Jun 16 04:30 proc-vmstat-redis.start
drwxr-xr-x 1 root root     8 Jun 16 04:30 redis
-rw-r--r-- 1 root root  8283 Jun 16 04:30 sysctl-tuning.gz
-rw-r--r-- 1 root root 35264 Jun 16 04:30 systemctl-units.txt
-rw-r--r-- 1 root root  3031 Jun 16 04:46 tests-activity
-rw-r--r-- 1 root root    12 Jun 16 04:46 tests-sysstate
-rw-r--r-- 1 root root  5816 Jun 16 04:46 tests-sysstate.gz
-rw-r--r-- 1 root root   168 Jun 16 04:46 tests-timestamp
-rw-r--r-- 1 root root    27 Jun 16 04:30 tuned-active-profile.txt
-rw-r--r-- 1 root root  1373 Jun 16 04:30 tuned-available-profile.txt
-rw-r--r-- 1 root root  3244 Jun 16 04:46 vmstat-redis.gz
-rw-r--r-- 1 root root    26 Jun 16 04:30 vmstat-redis.start
-rw-r--r-- 1 root root   585 Jun 16 04:30 vm-tuning.txt.gz

ls work/log/BASELINE/iter-0/redis/logs/ -l
total 108
-rw-r--r-- 1 root root 2926 Jun 16 04:46 mmtests.log.gz
-rw-r--r-- 1 root root  429 Jun 16 04:31 redis-1-1.log
-rw-r--r-- 1 root root  426 Jun 16 04:32 redis-1-2.log
-rw-r--r-- 1 root root  429 Jun 16 04:33 redis-1-3.log
-rw-r--r-- 1 root root  429 Jun 16 04:34 redis-1-4.log
-rw-r--r-- 1 root root  429 Jun 16 04:35 redis-1-5.log
-rw-r--r-- 1 root root  429 Jun 16 04:35 redis-3-1.log
-rw-r--r-- 1 root root  429 Jun 16 04:36 redis-3-2.log
-rw-r--r-- 1 root root  429 Jun 16 04:37 redis-3-3.log
-rw-r--r-- 1 root root  429 Jun 16 04:37 redis-3-4.log
-rw-r--r-- 1 root root  429 Jun 16 04:38 redis-3-5.log
-rw-r--r-- 1 root root  429 Jun 16 04:38 redis-5-1.log
-rw-r--r-- 1 root root  429 Jun 16 04:39 redis-5-2.log
-rw-r--r-- 1 root root  429 Jun 16 04:39 redis-5-3.log
-rw-r--r-- 1 root root  429 Jun 16 04:40 redis-5-4.log
-rw-r--r-- 1 root root  429 Jun 16 04:40 redis-5-5.log
-rw-r--r-- 1 root root  429 Jun 16 04:41 redis-7-1.log
-rw-r--r-- 1 root root  429 Jun 16 04:42 redis-7-2.log
-rw-r--r-- 1 root root  429 Jun 16 04:42 redis-7-3.log
-rw-r--r-- 1 root root  429 Jun 16 04:43 redis-7-4.log
-rw-r--r-- 1 root root  429 Jun 16 04:43 redis-7-5.log
-rw-r--r-- 1 root root  429 Jun 16 04:44 redis-8-1.log
-rw-r--r-- 1 root root  429 Jun 16 04:44 redis-8-2.log
-rw-r--r-- 1 root root  429 Jun 16 04:45 redis-8-3.log
-rw-r--r-- 1 root root  429 Jun 16 04:45 redis-8-4.log
-rw-r--r-- 1 root root  429 Jun 16 04:46 redis-8-5.log
-rw-r--r-- 1 root root 2180 Jun 16 04:46 redis-server.log
``` 

## Reporting

### Reporting with `compare-mmtests.pl`

```
./bin/compare-mmtests.pl --directory work/log/ --names BASELINE,BUSY --benchmark redis
                                      BASELINE                   BUSY
Min       1-PING_INLINE    23201.86 (   0.00%)    22639.80 (  -2.42%)
Min       1-PING_BULK      24218.94 (   0.00%)    24467.83 (   1.03%)
Min       1-SET            23014.96 (   0.00%)    24207.21 (   5.18%)
Min       1-GET            32164.68 (   0.00%)    25081.52 ( -22.02%)
Min       1-INCR           35323.21 (   0.00%)    23148.15 ( -34.47%)
Min       1-LPUSH          35868.00 (   0.00%)    18145.53 ( -49.41%)
Min       1-LPOP           35511.36 (   0.00%)    24813.89 ( -30.12%)
Min       1-SADD           33704.08 (   0.00%)    24026.91 ( -28.71%)
Min       1-SPOP           34554.25 (   0.00%)    25667.35 ( -25.72%)
Min       1-LRANGE_100     24557.96 (   0.00%)    14144.27 ( -42.40%)
Min       1-LRANGE_300      9855.13 (   0.00%)     9405.57 (  -4.56%)
Min       1-LRANGE_500      8113.59 (   0.00%)     7163.32 ( -11.71%)
Min       1-LRANGE_600      6460.37 (   0.00%)     5621.45 ( -12.99%)
Min       1-MSET-10        19083.97 (   0.00%)    18389.11 (  -3.64%)
Min       3-PING_INLINE    67204.30 (   0.00%)    51733.06 ( -23.02%)
Min       3-PING_BULK      69541.03 (   0.00%)    52002.08 ( -25.22%)
Min       3-SET            68587.11 (   0.00%)    54347.82 ( -20.76%)
Min       3-GET            68073.52 (   0.00%)    44583.15 ( -34.51%)
Min       3-INCR           71684.59 (   0.00%)    49285.36 ( -31.25%)
Min       3-LPUSH          66225.16 (   0.00%)    52631.58 ( -20.53%)
Min       3-LPOP           65316.79 (   0.00%)    53561.86 ( -18.00%)
Min       3-SADD           60790.27 (   0.00%)    50125.31 ( -17.54%)
Min       3-SPOP           67385.45 (   0.00%)    53276.50 ( -20.94%)
Min       3-LRANGE_100     42826.55 (   0.00%)    33422.46 ( -21.96%)
Min       3-LRANGE_300     22614.20 (   0.00%)    17256.26 ( -23.69%)
Min       3-LRANGE_500     18218.26 (   0.00%)    10380.98 ( -43.02%)
Min       3-LRANGE_600     15420.20 (   0.00%)     8392.08 ( -45.58%)
Min       3-MSET-10        56689.34 (   0.00%)    38699.69 ( -31.73%)
Min       5-PING_INLINE    71123.76 (   0.00%)    58241.12 ( -18.11%)
Min       5-PING_BULK      70126.23 (   0.00%)    50226.02 ( -28.38%)
Min       5-SET            71994.23 (   0.00%)    54171.18 ( -24.76%)
Min       5-GET            75872.54 (   0.00%)    51867.22 ( -31.64%)
Min       5-INCR           73260.07 (   0.00%)    58479.53 ( -20.18%)
Min       5-LPUSH          70224.72 (   0.00%)    48216.01 ( -31.34%)
Min       5-LPOP           69348.12 (   0.00%)    56689.34 ( -18.25%)
Min       5-SADD           65876.16 (   0.00%)    56211.35 ( -14.67%)
Min       5-SPOP           70472.16 (   0.00%)    58275.06 ( -17.31%)
Min       5-LRANGE_100     44802.86 (   0.00%)    29735.36 ( -33.63%)
Min       5-LRANGE_300     24937.65 (   0.00%)    13557.48 ( -45.63%)
Min       5-LRANGE_500     19573.30 (   0.00%)     9944.31 ( -49.19%)
Min       5-LRANGE_600     16431.15 (   0.00%)     7496.81 ( -54.37%)
Min       5-MSET-10        58072.01 (   0.00%)    42918.46 ( -26.09%)
Min       7-PING_INLINE    71123.76 (   0.00%)    57471.27 ( -19.20%)
Min       7-PING_BULK      70521.86 (   0.00%)    57603.69 ( -18.32%)
Min       7-SET            68917.99 (   0.00%)    51466.80 ( -25.32%)
Min       7-GET            69637.88 (   0.00%)    49726.51 ( -28.59%)
Min       7-INCR           70821.53 (   0.00%)    52994.17 ( -25.17%)
Min       7-LPUSH          67024.13 (   0.00%)    49800.80 ( -25.70%)
Min       7-LPOP           75815.01 (   0.00%)    52576.24 ( -30.65%)
Min       7-SADD           75815.01 (   0.00%)    56980.06 ( -24.84%)
Min       7-SPOP           74128.98 (   0.00%)    61842.92 ( -16.57%)
Min       7-LRANGE_100     47258.98 (   0.00%)    32341.53 ( -31.57%)
Min       7-LRANGE_300     24869.44 (   0.00%)    14729.71 ( -40.77%)
Min       7-LRANGE_500     18480.87 (   0.00%)     9242.14 ( -49.99%)
Min       7-LRANGE_600     16488.05 (   0.00%)     7372.46 ( -55.29%)
Min       7-MSET-10        60459.49 (   0.00%)    39510.08 ( -34.65%)
Min       8-PING_INLINE    69589.42 (   0.00%)    46728.97 ( -32.85%)
Min       8-PING_BULK      68399.45 (   0.00%)    52603.89 ( -23.09%)
Min       8-SET            76219.51 (   0.00%)    42247.57 ( -44.57%)
Min       8-GET            70972.32 (   0.00%)    53879.31 ( -24.08%)
Min       8-INCR           67659.00 (   0.00%)    50301.81 ( -25.65%)
Min       8-LPUSH          70372.98 (   0.00%)    42158.52 ( -40.09%)
Min       8-LPOP           73206.44 (   0.00%)    57208.24 ( -21.85%)
Min       8-SADD           72621.64 (   0.00%)    50916.50 ( -29.89%)
Min       8-SPOP           78740.16 (   0.00%)    44943.82 ( -42.92%)
Min       8-LRANGE_100     44111.16 (   0.00%)    30656.04 ( -30.50%)
Min       8-LRANGE_300     21958.72 (   0.00%)    13326.23 ( -39.31%)
Min       8-LRANGE_500     15683.81 (   0.00%)     9611.69 ( -38.72%)
Min       8-LRANGE_600     12745.35 (   0.00%)     7348.08 ( -42.35%)
Min       8-MSET-10        56850.48 (   0.00%)    42517.01 ( -25.21%)
Hmean     1-PING_INLINE    32419.12 (   0.00%)    24696.23 * -23.82%*
Hmean     1-PING_BULK      34690.90 (   0.00%)    27025.57 * -22.10%*
Hmean     1-SET            31788.42 (   0.00%)    26024.05 * -18.13%*
Hmean     1-GET            35343.18 (   0.00%)    26881.72 * -23.94%*
Hmean     1-INCR           36475.05 (   0.00%)    25729.43 * -29.46%*
Hmean     1-LPUSH          37181.63 (   0.00%)    27154.73 * -26.97%*
Hmean     1-LPOP           37271.71 (   0.00%)    27066.53 * -27.38%*
Hmean     1-SADD           35119.76 (   0.00%)    27802.49 * -20.84%*
Hmean     1-SPOP           36563.07 (   0.00%)    28428.47 * -22.25%*
Hmean     1-LRANGE_100     28137.31 (   0.00%)    18478.82 * -34.33%*
Hmean     1-LRANGE_300     15573.90 (   0.00%)    10530.31 * -32.38%*
Hmean     1-LRANGE_500     12717.79 (   0.00%)     8202.64 * -35.50%*
Hmean     1-LRANGE_600     10648.72 (   0.00%)     6504.91 * -38.91%*
Hmean     1-MSET-10        27135.57 (   0.00%)    22407.46 ( -17.42%)
Hmean     3-PING_INLINE    71541.00 (   0.00%)    55909.65 * -21.85%*
Hmean     3-PING_BULK      73464.59 (   0.00%)    56612.32 * -22.94%*
Hmean     3-SET            76359.19 (   0.00%)    59509.64 * -22.07%*
Hmean     3-GET            76300.93 (   0.00%)    59730.02 * -21.72%*
Hmean     3-INCR           73844.34 (   0.00%)    63848.80 ( -13.54%)
Hmean     3-LPUSH          71214.92 (   0.00%)    58407.80 * -17.98%*
Hmean     3-LPOP           68700.19 (   0.00%)    56471.65 * -17.80%*
Hmean     3-SADD           65189.05 (   0.00%)    58500.06 ( -10.26%)
Hmean     3-SPOP           71736.01 (   0.00%)    56167.15 * -21.70%*
Hmean     3-LRANGE_100     44839.03 (   0.00%)    35206.31 * -21.48%*
Hmean     3-LRANGE_300     24537.47 (   0.00%)    19947.34 * -18.71%*
Hmean     3-LRANGE_500     18830.98 (   0.00%)    12952.02 * -31.22%*
Hmean     3-LRANGE_600     16066.84 (   0.00%)    11180.18 * -30.41%*
Hmean     3-MSET-10        59192.61 (   0.00%)    42629.38 * -27.98%*
Hmean     5-PING_INLINE    75030.01 (   0.00%)    59616.07 * -20.54%*
Hmean     5-PING_BULK      77399.38 (   0.00%)    58241.12 * -24.75%*
Hmean     5-SET            74940.05 (   0.00%)    59171.60 * -21.04%*
Hmean     5-GET            79592.49 (   0.00%)    60753.34 * -23.67%*
Hmean     5-INCR           76781.32 (   0.00%)    61743.64 * -19.59%*
Hmean     5-LPUSH          75688.77 (   0.00%)    55784.89 * -26.30%*
Hmean     5-LPOP           74437.99 (   0.00%)    63979.52 * -14.05%*
Hmean     5-SADD           70422.54 (   0.00%)    61523.32 * -12.64%*
Hmean     5-SPOP           74327.34 (   0.00%)    62173.59 * -16.35%*
Hmean     5-LRANGE_100     48923.68 (   0.00%)    31371.57 * -35.88%*
Hmean     5-LRANGE_300     26481.65 (   0.00%)    16633.40 * -37.19%*
Hmean     5-LRANGE_500     20140.99 (   0.00%)    13207.60 * -34.42%*
Hmean     5-LRANGE_600     16959.50 (   0.00%)    10333.78 * -39.07%*
Hmean     5-MSET-10        63621.33 (   0.00%)    45008.55 * -29.26%*
Hmean     7-PING_INLINE    74604.59 (   0.00%)    61606.70 * -17.42%*
Hmean     7-PING_BULK      77006.00 (   0.00%)    63613.23 * -17.39%*
Hmean     7-SET            74827.90 (   0.00%)    58193.67 * -22.23%*
Hmean     7-GET            81579.38 (   0.00%)    58119.26 * -28.76%*
Hmean     7-INCR           76722.42 (   0.00%)    58851.22 * -23.29%*
Hmean     7-LPUSH          76417.55 (   0.00%)    60602.39 * -20.70%*
Hmean     7-LPOP           76840.33 (   0.00%)    59171.60 * -22.99%*
Hmean     7-SADD           78851.91 (   0.00%)    61251.99 * -22.32%*
Hmean     7-SPOP           80141.05 (   0.00%)    68643.60 * -14.35%*
Hmean     7-LRANGE_100     48899.76 (   0.00%)    39597.69 * -19.02%*
Hmean     7-LRANGE_300     25563.68 (   0.00%)    16927.92 * -33.78%*
Hmean     7-LRANGE_500     20000.80 (   0.00%)    11583.46 * -42.09%*
Hmean     7-LRANGE_600     16753.23 (   0.00%)     9661.65 * -42.33%*
Hmean     7-MSET-10        63669.94 (   0.00%)    48058.44 * -24.52%*
Hmean     8-PING_INLINE    73997.33 (   0.00%)    56876.35 * -23.14%*
Hmean     8-PING_BULK      75930.14 (   0.00%)    60598.71 * -20.19%*
Hmean     8-SET            79276.99 (   0.00%)    54692.63 * -31.01%*
Hmean     8-GET            78802.21 (   0.00%)    61515.75 * -21.94%*
Hmean     8-INCR           73616.02 (   0.00%)    61957.87 ( -15.84%)
Hmean     8-LPUSH          78462.14 (   0.00%)    62527.35 * -20.31%*
Hmean     8-LPOP           75018.75 (   0.00%)    63451.78 * -15.42%*
Hmean     8-SADD           76010.95 (   0.00%)    57570.52 * -24.26%*
Hmean     8-SPOP           82740.36 (   0.00%)    56439.78 * -31.79%*
Hmean     8-LRANGE_100     45020.71 (   0.00%)    38592.16 * -14.28%*
Hmean     8-LRANGE_300     23508.39 (   0.00%)    16026.16 * -31.83%*
Hmean     8-LRANGE_500     17094.60 (   0.00%)    13063.70 ( -23.58%)
Hmean     8-LRANGE_600     13959.07 (   0.00%)     9393.91 * -32.70%*
Hmean     8-MSET-10        61530.89 (   0.00%)    48657.07 * -20.92%*
Stddev    1-PING_INLINE     5829.00 (   0.00%)     1328.39 (  77.21%)
Stddev    1-PING_BULK       6692.90 (   0.00%)     3403.57 (  49.15%)
Stddev    1-SET             5573.04 (   0.00%)     2313.88 (  58.48%)
Stddev    1-GET             2256.62 (   0.00%)     2016.66 (  10.63%)
Stddev    1-INCR            1711.89 (   0.00%)     2953.87 ( -72.55%)
Stddev    1-LPUSH           1047.81 (   0.00%)     4756.49 (-353.94%)
Stddev    1-LPOP            1299.04 (   0.00%)     2747.40 (-111.50%)
Stddev    1-SADD            1665.78 (   0.00%)     3971.27 (-138.40%)
Stddev    1-SPOP            1418.56 (   0.00%)     3242.17 (-128.55%)
Stddev    1-LRANGE_100      2214.50 (   0.00%)     3230.29 ( -45.87%)
Stddev    1-LRANGE_300      3796.07 (   0.00%)     1189.79 (  68.66%)
Stddev    1-LRANGE_500      3076.94 (   0.00%)     1599.39 (  48.02%)
Stddev    1-LRANGE_600      2892.27 (   0.00%)     1069.36 (  63.03%)
Stddev    1-MSET-10         5603.16 (   0.00%)     4130.64 (  26.28%)
Stddev    3-PING_INLINE     3628.76 (   0.00%)     3349.65 (   7.69%)
Stddev    3-PING_BULK       2632.70 (   0.00%)     6238.77 (-136.97%)
Stddev    3-SET             7167.93 (   0.00%)     4955.92 (  30.86%)
Stddev    3-GET             6605.67 (   0.00%)    15329.78 (-132.07%)
Stddev    3-INCR            2925.69 (   0.00%)    12262.04 (-319.12%)
Stddev    3-LPUSH           3896.81 (   0.00%)     4523.32 ( -16.08%)
Stddev    3-LPOP            4704.39 (   0.00%)     2993.29 (  36.37%)
Stddev    3-SADD            3323.46 (   0.00%)     7584.83 (-128.22%)
Stddev    3-SPOP            4487.28 (   0.00%)     2274.98 (  49.30%)
Stddev    3-LRANGE_100      2671.44 (   0.00%)     1417.94 (  46.92%)
Stddev    3-LRANGE_300      1293.61 (   0.00%)     3032.13 (-134.39%)
Stddev    3-LRANGE_500       478.40 (   0.00%)     2307.10 (-382.25%)
Stddev    3-LRANGE_600       392.88 (   0.00%)     3441.95 (-776.08%)
Stddev    3-MSET-10         3753.46 (   0.00%)     4323.20 ( -15.18%)
Stddev    5-PING_INLINE     4680.72 (   0.00%)     1022.35 (  78.16%)
Stddev    5-PING_BULK       6782.40 (   0.00%)     5061.65 (  25.37%)
Stddev    5-SET             2207.38 (   0.00%)     3090.58 ( -40.01%)
Stddev    5-GET             3464.36 (   0.00%)     9509.11 (-174.48%)
Stddev    5-INCR            3437.23 (   0.00%)     2990.64 (  12.99%)
Stddev    5-LPUSH           3732.69 (   0.00%)     4540.13 ( -21.63%)
Stddev    5-LPOP            3911.23 (   0.00%)    11868.13 (-203.44%)
Stddev    5-SADD            3688.33 (   0.00%)     3180.78 (  13.76%)
Stddev    5-SPOP            5843.11 (   0.00%)     3252.60 (  44.33%)
Stddev    5-LRANGE_100      2385.03 (   0.00%)     1200.19 (  49.68%)
Stddev    5-LRANGE_300      1453.23 (   0.00%)     1880.46 ( -29.40%)
Stddev    5-LRANGE_500       797.91 (   0.00%)     3276.04 (-310.58%)
Stddev    5-LRANGE_600       335.94 (   0.00%)     3987.61 (-1086.99%)
Stddev    5-MSET-10         3191.56 (   0.00%)     2269.08 (  28.90%)
Stddev    7-PING_INLINE     4213.42 (   0.00%)     3822.36 (   9.28%)
Stddev    7-PING_BULK       4326.00 (   0.00%)     7052.75 ( -63.03%)
Stddev    7-SET             5306.78 (   0.00%)     4404.63 (  17.00%)
Stddev    7-GET             9504.29 (   0.00%)     8276.54 (  12.92%)
Stddev    7-INCR            3846.92 (   0.00%)     3962.99 (  -3.02%)
Stddev    7-LPUSH           7850.05 (   0.00%)     7701.19 (   1.90%)
Stddev    7-LPOP            1259.06 (   0.00%)     4544.95 (-260.98%)
Stddev    7-SADD            2215.20 (   0.00%)     2870.54 ( -29.58%)
Stddev    7-SPOP            4483.64 (   0.00%)     8989.24 (-100.49%)
Stddev    7-LRANGE_100      2049.66 (   0.00%)     7785.56 (-279.85%)
Stddev    7-LRANGE_300       560.41 (   0.00%)     1966.17 (-250.85%)
Stddev    7-LRANGE_500       958.41 (   0.00%)     2070.11 (-115.99%)
Stddev    7-LRANGE_600       464.48 (   0.00%)     3035.06 (-553.43%)
Stddev    7-MSET-10         2506.20 (   0.00%)    15264.54 (-509.07%)
Stddev    8-PING_INLINE     3188.70 (   0.00%)     7632.60 (-139.36%)
Stddev    8-PING_BULK       7780.01 (   0.00%)     8742.50 ( -12.37%)
Stddev    8-SET             2916.77 (   0.00%)     8392.44 (-187.73%)
Stddev    8-GET             5805.48 (   0.00%)     6809.48 ( -17.29%)
Stddev    8-INCR            6406.50 (   0.00%)    14642.07 (-128.55%)
Stddev    8-LPUSH           6192.70 (   0.00%)    17725.61 (-186.23%)
Stddev    8-LPOP            2680.17 (   0.00%)     8054.31 (-200.51%)
Stddev    8-SADD            2198.62 (   0.00%)     7231.05 (-228.89%)
Stddev    8-SPOP            3384.00 (   0.00%)     7910.13 (-133.75%)
Stddev    8-LRANGE_100       859.97 (   0.00%)     7600.91 (-783.85%)
Stddev    8-LRANGE_300      1512.85 (   0.00%)     4270.56 (-182.29%)
Stddev    8-LRANGE_500      1367.87 (   0.00%)     5152.22 (-276.66%)
Stddev    8-LRANGE_600      1090.95 (   0.00%)     3140.45 (-187.86%)
Stddev    8-MSET-10         3842.50 (   0.00%)     5966.88 ( -55.29%)
CoeffVar  1-PING_INLINE       17.42 (   0.00%)        5.37 (  69.20%)
CoeffVar  1-PING_BULK         18.60 (   0.00%)       12.45 (  33.08%)
CoeffVar  1-SET               17.02 (   0.00%)        8.84 (  48.07%)
CoeffVar  1-GET                6.36 (   0.00%)        7.47 ( -17.36%)
CoeffVar  1-INCR               4.69 (   0.00%)       11.37 (-142.63%)
CoeffVar  1-LPUSH              2.82 (   0.00%)       16.98 (-503.08%)
CoeffVar  1-LPOP               3.48 (   0.00%)       10.07 (-189.22%)
CoeffVar  1-SADD               4.74 (   0.00%)       14.06 (-196.92%)
CoeffVar  1-SPOP               3.88 (   0.00%)       11.29 (-191.36%)
CoeffVar  1-LRANGE_100         7.83 (   0.00%)       17.03 (-117.53%)
CoeffVar  1-LRANGE_300        22.92 (   0.00%)       11.19 (  51.20%)
CoeffVar  1-LRANGE_500        22.79 (   0.00%)       19.02 (  16.56%)
CoeffVar  1-LRANGE_600        25.17 (   0.00%)       16.11 (  35.99%)
CoeffVar  1-MSET-10           19.85 (   0.00%)       17.98 (   9.43%)
CoeffVar  3-PING_INLINE        5.06 (   0.00%)        5.97 ( -18.02%)
CoeffVar  3-PING_BULK          3.58 (   0.00%)       10.93 (-205.18%)
CoeffVar  3-SET                9.32 (   0.00%)        8.28 (  11.12%)
CoeffVar  3-GET                8.61 (   0.00%)       24.46 (-184.21%)
CoeffVar  3-INCR               3.96 (   0.00%)       18.63 (-370.88%)
CoeffVar  3-LPUSH              5.46 (   0.00%)        7.71 ( -41.20%)
CoeffVar  3-LPOP               6.82 (   0.00%)        5.29 (  22.49%)
CoeffVar  3-SADD               5.09 (   0.00%)       12.80 (-151.64%)
CoeffVar  3-SPOP               6.24 (   0.00%)        4.05 (  35.14%)
CoeffVar  3-LRANGE_100         5.94 (   0.00%)        4.02 (  32.31%)
CoeffVar  3-LRANGE_300         5.26 (   0.00%)       14.96 (-184.38%)
CoeffVar  3-LRANGE_500         2.54 (   0.00%)       17.37 (-583.97%)
CoeffVar  3-LRANGE_600         2.44 (   0.00%)       28.72 (-1075.02%)
CoeffVar  3-MSET-10            6.32 (   0.00%)       10.06 ( -59.18%)
CoeffVar  5-PING_INLINE        6.22 (   0.00%)        1.71 (  72.43%)
CoeffVar  5-PING_BULK          8.71 (   0.00%)        8.63 (   0.89%)
CoeffVar  5-SET                2.94 (   0.00%)        5.21 ( -77.04%)
CoeffVar  5-GET                4.35 (   0.00%)       15.38 (-253.93%)
CoeffVar  5-INCR               4.47 (   0.00%)        4.83 (  -8.17%)
CoeffVar  5-LPUSH              4.92 (   0.00%)        8.09 ( -64.41%)
CoeffVar  5-LPOP               5.24 (   0.00%)       18.15 (-246.15%)
CoeffVar  5-SADD               5.23 (   0.00%)        5.16 (   1.29%)
CoeffVar  5-SPOP               7.83 (   0.00%)        5.22 (  33.30%)
CoeffVar  5-LRANGE_100         4.87 (   0.00%)        3.82 (  21.46%)
CoeffVar  5-LRANGE_300         5.47 (   0.00%)       11.17 (-104.12%)
CoeffVar  5-LRANGE_500         3.96 (   0.00%)       23.70 (-498.94%)
CoeffVar  5-LRANGE_600         1.98 (   0.00%)       34.98 (-1666.37%)
CoeffVar  5-MSET-10            5.01 (   0.00%)        5.03 (  -0.51%)
CoeffVar  7-PING_INLINE        5.63 (   0.00%)        6.19 (  -9.80%)
CoeffVar  7-PING_BULK          5.60 (   0.00%)       10.98 ( -96.02%)
CoeffVar  7-SET                7.06 (   0.00%)        7.53 (  -6.62%)
CoeffVar  7-GET               11.53 (   0.00%)       14.02 ( -21.65%)
CoeffVar  7-INCR               5.00 (   0.00%)        6.71 ( -34.07%)
CoeffVar  7-LPUSH             10.18 (   0.00%)       12.54 ( -23.19%)
CoeffVar  7-LPOP               1.64 (   0.00%)        7.64 (-366.57%)
CoeffVar  7-SADD               2.81 (   0.00%)        4.68 ( -66.62%)
CoeffVar  7-SPOP               5.58 (   0.00%)       12.93 (-131.74%)
CoeffVar  7-LRANGE_100         4.19 (   0.00%)       19.06 (-355.40%)
CoeffVar  7-LRANGE_300         2.19 (   0.00%)       11.49 (-424.32%)
CoeffVar  7-LRANGE_500         4.78 (   0.00%)       17.42 (-264.27%)
CoeffVar  7-LRANGE_600         2.77 (   0.00%)       29.64 (-969.65%)
CoeffVar  7-MSET-10            3.93 (   0.00%)       30.05 (-664.35%)
CoeffVar  8-PING_INLINE        4.30 (   0.00%)       13.22 (-207.34%)
CoeffVar  8-PING_BULK         10.16 (   0.00%)       14.20 ( -39.68%)
CoeffVar  8-SET                3.68 (   0.00%)       15.03 (-308.84%)
CoeffVar  8-GET                7.33 (   0.00%)       10.97 ( -49.54%)
CoeffVar  8-INCR               8.65 (   0.00%)       22.81 (-163.68%)
CoeffVar  8-LPUSH              7.85 (   0.00%)       26.77 (-241.02%)
CoeffVar  8-LPOP               3.57 (   0.00%)       12.54 (-251.35%)
CoeffVar  8-SADD               2.89 (   0.00%)       12.41 (-329.40%)
CoeffVar  8-SPOP               4.08 (   0.00%)       13.78 (-237.33%)
CoeffVar  8-LRANGE_100         1.91 (   0.00%)       19.14 (-902.54%)
CoeffVar  8-LRANGE_300         6.41 (   0.00%)       25.48 (-297.23%)
CoeffVar  8-LRANGE_500         7.96 (   0.00%)       36.27 (-355.50%)
CoeffVar  8-LRANGE_600         7.78 (   0.00%)       31.03 (-298.99%)
CoeffVar  8-MSET-10            6.23 (   0.00%)       12.13 ( -94.79%)
Max       1-PING_INLINE    37835.79 (   0.00%)    26329.65 ( -30.41%)
Max       1-PING_BULK      40683.48 (   0.00%)    31786.40 ( -21.87%)
Max       1-SET            36603.22 (   0.00%)    29299.74 ( -19.95%)
Max       1-GET            38270.19 (   0.00%)    29103.61 ( -23.95%)
Max       1-INCR           39541.32 (   0.00%)    30469.22 ( -22.94%)
Max       1-LPUSH          39541.32 (   0.00%)    34674.06 ( -12.31%)
Max       1-LPOP           38654.81 (   0.00%)    30769.23 ( -20.40%)
Max       1-SADD           38022.81 (   0.00%)    32851.51 ( -13.60%)
Max       1-SPOP           38535.64 (   0.00%)    32478.08 ( -15.72%)
Max       1-LRANGE_100     30422.88 (   0.00%)    22232.10 ( -26.92%)
Max       1-LRANGE_300     18942.98 (   0.00%)    11920.37 ( -37.07%)
Max       1-LRANGE_500     15915.96 (   0.00%)    11100.01 ( -30.26%)
Max       1-LRANGE_600     13489.82 (   0.00%)     7987.86 ( -40.79%)
Max       1-MSET-10        32927.23 (   0.00%)    28473.80 ( -13.53%)
Max       3-PING_INLINE    75872.54 (   0.00%)    60642.81 ( -20.07%)
Max       3-PING_BULK      76511.09 (   0.00%)    67704.80 ( -11.51%)
Max       3-SET            84459.46 (   0.00%)    67159.17 ( -20.48%)
Max       3-GET            86058.52 (   0.00%)    83542.19 (  -2.92%)
Max       3-INCR           78926.60 (   0.00%)    78926.60 (   0.00%)
Max       3-LPUSH          78492.93 (   0.00%)    69783.67 ( -11.10%)
Max       3-LPOP           76569.68 (   0.00%)    60496.07 ( -20.99%)
Max       3-SADD           69881.20 (   0.00%)    70871.72 (   1.42%)
Max       3-SPOP           78616.35 (   0.00%)    58823.53 ( -25.18%)
Max       3-LRANGE_100     49603.17 (   0.00%)    36724.20 ( -25.96%)
Max       3-LRANGE_300     26157.47 (   0.00%)    25361.40 (  -3.04%)
Max       3-LRANGE_500     19493.18 (   0.00%)    16092.69 ( -17.44%)
Max       3-LRANGE_600     16452.78 (   0.00%)    15807.78 (  -3.92%)
Max       3-MSET-10        65963.06 (   0.00%)    49726.51 ( -24.61%)
Max       5-PING_INLINE    82101.80 (   0.00%)    60827.25 ( -25.91%)
Max       5-PING_BULK      88573.96 (   0.00%)    63938.62 ( -27.81%)
Max       5-SET            77459.34 (   0.00%)    62034.74 ( -19.91%)
Max       5-GET            84175.09 (   0.00%)    77220.08 (  -8.26%)
Max       5-INCR           81103.00 (   0.00%)    65019.51 ( -19.83%)
Max       5-LPUSH          80775.45 (   0.00%)    62853.55 ( -22.19%)
Max       5-LPOP           80385.85 (   0.00%)    86281.27 (   7.33%)
Max       5-SADD           74515.65 (   0.00%)    63979.53 ( -14.14%)
Max       5-SPOP           84889.65 (   0.00%)    67204.30 ( -20.83%)
Max       5-LRANGE_100     50454.09 (   0.00%)    32797.64 ( -35.00%)
Max       5-LRANGE_300     28344.67 (   0.00%)    17979.14 ( -36.57%)
Max       5-LRANGE_500     21331.06 (   0.00%)    17605.63 ( -17.46%)
Max       5-LRANGE_600     17283.10 (   0.00%)    15807.78 (  -8.54%)
Max       5-MSET-10        65487.89 (   0.00%)    47824.00 ( -26.97%)
Max       7-PING_INLINE    81833.06 (   0.00%)    67750.68 ( -17.21%)
Max       7-PING_BULK      81300.81 (   0.00%)    72254.34 ( -11.13%)
Max       7-SET            83194.67 (   0.00%)    62266.50 ( -25.16%)
Max       7-GET            96153.85 (   0.00%)    70771.41 ( -26.40%)
Max       7-INCR           80580.17 (   0.00%)    62539.09 ( -22.39%)
Max       7-LPUSH          89445.44 (   0.00%)    78740.16 ( -11.97%)
Max       7-LPOP           78926.60 (   0.00%)    64143.68 ( -18.73%)
Max       7-SADD           81103.00 (   0.00%)    64599.48 ( -20.35%)
Max       7-SPOP           85689.80 (   0.00%)    82918.74 (  -3.23%)
Max       7-LRANGE_100     51572.98 (   0.00%)    49236.83 (  -4.53%)
Max       7-LRANGE_300     26136.96 (   0.00%)    19047.62 ( -27.12%)
Max       7-LRANGE_500     20898.64 (   0.00%)    14432.10 ( -30.94%)
Max       7-LRANGE_600     17587.06 (   0.00%)    15389.35 ( -12.50%)
Max       7-MSET-10        66137.57 (   0.00%)    77519.38 (  17.21%)
Max       8-PING_INLINE    78554.59 (   0.00%)    67842.61 ( -13.64%)
Max       8-PING_BULK      86956.52 (   0.00%)    72886.30 ( -16.18%)
Max       8-SET            83963.05 (   0.00%)    63051.70 ( -24.91%)
Max       8-GET            85178.88 (   0.00%)    72780.20 ( -14.56%)
Max       8-INCR           80906.16 (   0.00%)    89047.20 (  10.06%)
Max       8-LPUSH          91996.32 (   0.00%)   104821.80 (  13.94%)
Max       8-LPOP           79744.82 (   0.00%)    73855.24 (  -7.39%)
Max       8-SADD           77881.62 (   0.00%)    68073.52 ( -12.59%)
Max       8-SPOP           88105.73 (   0.00%)    65104.17 ( -26.11%)
Max       8-LRANGE_100     46274.87 (   0.00%)    51098.62 (  10.42%)
Max       8-LRANGE_300     25380.71 (   0.00%)    23691.07 (  -6.66%)
Max       8-LRANGE_500     19425.02 (   0.00%)    22988.51 (  18.34%)
Max       8-LRANGE_600     15610.37 (   0.00%)    13894.68 ( -10.99%)
Max       8-MSET-10        65487.89 (   0.00%)    58411.21 ( -10.81%)
BHmean-50 1-PING_INLINE    36630.04 (   0.00%)    25644.31 ( -29.99%)
BHmean-50 1-PING_BULK      40064.10 (   0.00%)    30983.74 ( -22.66%)
BHmean-50 1-SET            36016.57 (   0.00%)    28628.69 ( -20.51%)
BHmean-50 1-GET            37425.15 (   0.00%)    29103.61 ( -22.24%)
BHmean-50 1-INCR           37800.04 (   0.00%)    28801.84 ( -23.80%)
BHmean-50 1-LPUSH          37910.38 (   0.00%)    31265.63 ( -17.53%)
BHmean-50 1-LPOP           38417.21 (   0.00%)    30156.81 ( -21.50%)
BHmean-50 1-SADD           36489.69 (   0.00%)    32247.66 ( -11.63%)
BHmean-50 1-SPOP           37693.18 (   0.00%)    32107.88 ( -14.82%)
BHmean-50 1-LRANGE_100     29832.94 (   0.00%)    21706.10 ( -27.24%)
BHmean-50 1-LRANGE_300     18677.62 (   0.00%)    11836.42 ( -36.63%)
BHmean-50 1-LRANGE_500     15284.68 (   0.00%)     9684.29 ( -36.64%)
BHmean-50 1-LRANGE_600     13278.45 (   0.00%)     7772.12 ( -41.47%)
BHmean-50 1-MSET-10        32175.03 (   0.00%)    27173.91 ( -15.54%)
BHmean-50 3-PING_INLINE    75244.55 (   0.00%)    59136.60 ( -21.41%)
BHmean-50 3-PING_BULK      75642.96 (   0.00%)    61519.53 ( -18.67%)
BHmean-50 3-SET            83333.33 (   0.00%)    64578.62 ( -22.51%)
BHmean-50 3-GET            82610.49 (   0.00%)    77309.63 (  -6.42%)
BHmean-50 3-INCR           76161.46 (   0.00%)    76834.42 (   0.88%)
BHmean-50 3-LPUSH          74172.97 (   0.00%)    61334.64 ( -17.31%)
BHmean-50 3-LPOP           73367.57 (   0.00%)    59154.10 ( -19.37%)
BHmean-50 3-SADD           68166.33 (   0.00%)    65466.45 (  -3.96%)
BHmean-50 3-SPOP           75958.98 (   0.00%)    58224.16 ( -23.35%)
BHmean-50 3-LRANGE_100     46915.32 (   0.00%)    36683.79 ( -21.81%)
BHmean-50 3-LRANGE_300     25581.99 (   0.00%)    22386.39 ( -12.49%)
BHmean-50 3-LRANGE_500     19241.87 (   0.00%)    15205.66 ( -20.98%)
BHmean-50 3-LRANGE_600     16367.95 (   0.00%)    15384.62 (  -6.01%)
BHmean-50 3-MSET-10        62053.99 (   0.00%)    46360.69 ( -25.29%)
BHmean-50 5-PING_INLINE    79968.01 (   0.00%)    60459.49 ( -24.40%)
BHmean-50 5-PING_BULK      83437.63 (   0.00%)    61977.07 ( -25.72%)
BHmean-50 5-SET            76775.43 (   0.00%)    61576.35 ( -19.80%)
BHmean-50 5-GET            82987.55 (   0.00%)    68634.18 ( -17.30%)
BHmean-50 5-INCR           80256.82 (   0.00%)    65019.51 ( -18.99%)
BHmean-50 5-LPUSH          78926.60 (   0.00%)    59566.36 ( -24.53%)
BHmean-50 5-LPOP           77369.44 (   0.00%)    72463.76 (  -6.34%)
BHmean-50 5-SADD           74019.24 (   0.00%)    63816.21 ( -13.78%)
BHmean-50 5-SPOP           78709.17 (   0.00%)    64956.15 ( -17.47%)
BHmean-50 5-LRANGE_100     50377.83 (   0.00%)    32520.32 ( -35.45%)
BHmean-50 5-LRANGE_300     27960.30 (   0.00%)    17969.45 ( -35.73%)
BHmean-50 5-LRANGE_500     20995.17 (   0.00%)    17226.53 ( -17.95%)
BHmean-50 5-LRANGE_600     17219.11 (   0.00%)    15605.49 (  -9.37%)
BHmean-50 5-MSET-10        65445.03 (   0.00%)    47460.84 ( -27.48%)
BHmean-50 7-PING_INLINE    78155.53 (   0.00%)    65125.36 ( -16.67%)
BHmean-50 7-PING_BULK      80612.65 (   0.00%)    71813.29 ( -10.92%)
BHmean-50 7-SET            79776.63 (   0.00%)    61804.70 ( -22.53%)
BHmean-50 7-GET            89887.64 (   0.00%)    66247.10 ( -26.30%)
BHmean-50 7-INCR           79936.05 (   0.00%)    62363.58 ( -21.98%)
BHmean-50 7-LPUSH          83752.09 (   0.00%)    65694.39 ( -21.56%)
BHmean-50 7-LPOP           77881.62 (   0.00%)    63251.11 ( -18.79%)
BHmean-50 7-SADD           81037.28 (   0.00%)    63593.00 ( -21.53%)
BHmean-50 7-SPOP           83927.82 (   0.00%)    78523.76 (  -6.44%)
BHmean-50 7-LRANGE_100     51177.07 (   0.00%)    47314.88 (  -7.55%)
BHmean-50 7-LRANGE_300     26126.72 (   0.00%)    18986.14 ( -27.33%)
BHmean-50 7-LRANGE_500     20733.98 (   0.00%)    13647.22 ( -34.18%)
BHmean-50 7-LRANGE_600     17099.86 (   0.00%)    12105.80 ( -29.21%)
BHmean-50 7-MSET-10        65963.07 (   0.00%)    59189.11 ( -10.27%)
BHmean-50 8-PING_INLINE    76569.68 (   0.00%)    63836.58 ( -16.63%)
BHmean-50 8-PING_BULK      84423.80 (   0.00%)    69881.20 ( -17.23%)
BHmean-50 8-SET            81933.63 (   0.00%)    62774.64 ( -23.38%)
BHmean-50 8-GET            84139.67 (   0.00%)    67024.13 ( -20.34%)
BHmean-50 8-INCR           80742.84 (   0.00%)    73448.40 (  -9.03%)
BHmean-50 8-LPUSH          82754.06 (   0.00%)    74128.98 ( -10.42%)
BHmean-50 8-LPOP           77279.75 (   0.00%)    72939.46 (  -5.62%)
BHmean-50 8-SADD           77790.74 (   0.00%)    65746.22 ( -15.48%)
BHmean-50 8-SPOP           85506.63 (   0.00%)    64184.85 ( -24.94%)
BHmean-50 8-LRANGE_100     45798.03 (   0.00%)    46296.30 (   1.09%)
BHmean-50 8-LRANGE_300     25176.23 (   0.00%)    20358.31 ( -19.14%)
BHmean-50 8-LRANGE_500     18137.30 (   0.00%)    17383.75 (  -4.15%)
BHmean-50 8-LRANGE_600     14984.65 (   0.00%)    13458.05 ( -10.19%)
BHmean-50 8-MSET-10        64913.99 (   0.00%)    53879.31 ( -17.00%)
BHmean-95 1-PING_INLINE    35993.88 (   0.00%)    25270.07 ( -29.79%)
BHmean-95 1-PING_BULK      38895.37 (   0.00%)    27750.80 ( -28.65%)
BHmean-95 1-SET            35137.04 (   0.00%)    26521.69 ( -24.52%)
BHmean-95 1-GET            36238.45 (   0.00%)    27372.89 ( -24.46%)
BHmean-95 1-INCR           36774.85 (   0.00%)    26467.28 ( -28.03%)
BHmean-95 1-LPUSH          37333.55 (   0.00%)    28740.22 ( -23.02%)
BHmean-95 1-LPOP           37739.41 (   0.00%)    27695.08 ( -26.61%)
BHmean-95 1-SADD           35492.46 (   0.00%)    28939.37 ( -18.46%)
BHmean-95 1-SPOP           37102.31 (   0.00%)    29214.14 ( -21.26%)
BHmean-95 1-LRANGE_100     29201.35 (   0.00%)    20012.01 ( -31.47%)
BHmean-95 1-LRANGE_300     18216.60 (   0.00%)    10854.82 ( -40.41%)
BHmean-95 1-LRANGE_500     14820.30 (   0.00%)     8511.36 ( -42.57%)
BHmean-95 1-LRANGE_600     12708.50 (   0.00%)     6770.94 ( -46.72%)
BHmean-95 1-MSET-10        30335.20 (   0.00%)    23702.30 ( -21.87%)
BHmean-95 3-PING_INLINE    72714.06 (   0.00%)    57061.34 ( -21.53%)
BHmean-95 3-PING_BULK      74515.65 (   0.00%)    57895.50 ( -22.30%)
BHmean-95 3-SET            78585.46 (   0.00%)    60957.03 ( -22.43%)
BHmean-95 3-GET            78678.21 (   0.00%)    65274.16 ( -17.04%)
BHmean-95 3-INCR           74404.76 (   0.00%)    68941.74 (  -7.34%)
BHmean-95 3-LPUSH          71816.15 (   0.00%)    59128.84 ( -17.67%)
BHmean-95 3-LPOP           69601.53 (   0.00%)    57249.18 ( -17.75%)
BHmean-95 3-SADD           66390.04 (   0.00%)    61050.06 (  -8.04%)
BHmean-95 3-SPOP           72912.87 (   0.00%)    56939.51 ( -21.91%)
BHmean-95 3-LRANGE_100     45372.05 (   0.00%)    35682.43 ( -21.36%)
BHmean-95 3-LRANGE_300     25070.51 (   0.00%)    20756.57 ( -17.21%)
BHmean-95 3-LRANGE_500     18990.65 (   0.00%)    13806.91 ( -27.30%)
BHmean-95 3-LRANGE_600     16237.06 (   0.00%)    12192.89 ( -24.91%)
BHmean-95 3-MSET-10        59853.36 (   0.00%)    43739.75 ( -26.92%)
BHmean-95 5-PING_INLINE    76074.55 (   0.00%)    59970.02 ( -21.17%)
BHmean-95 5-PING_BULK      79459.67 (   0.00%)    60661.21 ( -23.66%)
BHmean-95 5-SET            75714.56 (   0.00%)    60569.35 ( -20.00%)
BHmean-95 5-GET            80580.18 (   0.00%)    63471.91 ( -21.23%)
BHmean-95 5-INCR           77715.17 (   0.00%)    62617.41 ( -19.43%)
BHmean-95 5-LPUSH          76348.83 (   0.00%)    56775.17 ( -25.64%)
BHmean-95 5-LPOP           75829.39 (   0.00%)    66104.77 ( -12.82%)
BHmean-95 5-SADD           71658.90 (   0.00%)    63011.97 ( -12.07%)
BHmean-95 5-SPOP           75357.95 (   0.00%)    63231.11 ( -16.09%)
BHmean-95 5-LRANGE_100     50075.12 (   0.00%)    31809.15 ( -36.48%)
BHmean-95 5-LRANGE_300     26897.99 (   0.00%)    17633.57 ( -34.44%)
BHmean-95 5-LRANGE_500     20288.09 (   0.00%)    14387.97 ( -29.08%)
BHmean-95 5-LRANGE_600     17096.94 (   0.00%)    11413.57 ( -33.24%)
BHmean-95 5-MSET-10        65178.43 (   0.00%)    45563.28 ( -30.09%)
BHmean-95 7-PING_INLINE    75528.70 (   0.00%)    62735.26 ( -16.94%)
BHmean-95 7-PING_BULK      78817.73 (   0.00%)    65316.79 ( -17.13%)
BHmean-95 7-SET            76467.21 (   0.00%)    60159.42 ( -21.33%)
BHmean-95 7-GET            85233.33 (   0.00%)    60679.61 ( -28.81%)
BHmean-95 7-INCR           78354.55 (   0.00%)    60523.53 ( -22.76%)
BHmean-95 7-LPUSH          77626.36 (   0.00%)    62098.94 ( -20.00%)
BHmean-95 7-LPOP           77101.00 (   0.00%)    61087.35 ( -20.77%)
BHmean-95 7-SADD           79649.54 (   0.00%)    62421.97 ( -21.63%)
BHmean-95 7-SPOP           81799.59 (   0.00%)    70584.08 ( -13.71%)
BHmean-95 7-LRANGE_100     49327.91 (   0.00%)    41950.71 ( -14.96%)
BHmean-95 7-LRANGE_300     25743.34 (   0.00%)    17583.96 ( -31.70%)
BHmean-95 7-LRANGE_500     20420.67 (   0.00%)    12366.67 ( -39.44%)
BHmean-95 7-LRANGE_600     16820.86 (   0.00%)    10474.77 ( -37.73%)
BHmean-95 7-MSET-10        64526.54 (   0.00%)    50806.55 ( -21.26%)
BHmean-95 8-PING_INLINE    75187.97 (   0.00%)    60141.33 ( -20.01%)
BHmean-95 8-PING_BULK      78079.25 (   0.00%)    62992.12 ( -19.32%)
BHmean-95 8-SET            80080.08 (   0.00%)    59040.59 ( -26.27%)
BHmean-95 8-GET            81037.28 (   0.00%)    63775.51 ( -21.30%)
BHmean-95 8-INCR           75272.86 (   0.00%)    65767.84 ( -12.63%)
BHmean-95 8-LPUSH          79477.22 (   0.00%)    66074.44 ( -16.86%)
BHmean-95 8-LPOP           75485.94 (   0.00%)    65231.57 ( -13.58%)
BHmean-95 8-SADD           76908.29 (   0.00%)    59514.95 ( -22.62%)
BHmean-95 8-SPOP           83804.74 (   0.00%)    60295.45 ( -28.05%)
BHmean-95 8-LRANGE_100     45253.98 (   0.00%)    41262.64 (  -8.82%)
BHmean-95 8-LRANGE_300     23930.60 (   0.00%)    16881.20 ( -29.46%)
BHmean-95 8-LRANGE_500     17487.87 (   0.00%)    14352.35 ( -17.93%)
BHmean-95 8-LRANGE_600     14299.50 (   0.00%)    10096.68 ( -29.39%)
BHmean-95 8-MSET-10        62823.93 (   0.00%)    50479.56 ( -19.65%)
BHmean-99 1-PING_INLINE    35993.88 (   0.00%)    25270.07 ( -29.79%)
BHmean-99 1-PING_BULK      38895.37 (   0.00%)    27750.80 ( -28.65%)
BHmean-99 1-SET            35137.04 (   0.00%)    26521.69 ( -24.52%)
BHmean-99 1-GET            36238.45 (   0.00%)    27372.89 ( -24.46%)
BHmean-99 1-INCR           36774.85 (   0.00%)    26467.28 ( -28.03%)
BHmean-99 1-LPUSH          37333.55 (   0.00%)    28740.22 ( -23.02%)
BHmean-99 1-LPOP           37739.41 (   0.00%)    27695.08 ( -26.61%)
BHmean-99 1-SADD           35492.46 (   0.00%)    28939.37 ( -18.46%)
BHmean-99 1-SPOP           37102.31 (   0.00%)    29214.14 ( -21.26%)
BHmean-99 1-LRANGE_100     29201.35 (   0.00%)    20012.01 ( -31.47%)
BHmean-99 1-LRANGE_300     18216.60 (   0.00%)    10854.82 ( -40.41%)
BHmean-99 1-LRANGE_500     14820.30 (   0.00%)     8511.36 ( -42.57%)
BHmean-99 1-LRANGE_600     12708.50 (   0.00%)     6770.94 ( -46.72%)
BHmean-99 1-MSET-10        30335.20 (   0.00%)    23702.30 ( -21.87%)
BHmean-99 3-PING_INLINE    72714.06 (   0.00%)    57061.34 ( -21.53%)
BHmean-99 3-PING_BULK      74515.65 (   0.00%)    57895.50 ( -22.30%)
BHmean-99 3-SET            78585.46 (   0.00%)    60957.03 ( -22.43%)
BHmean-99 3-GET            78678.21 (   0.00%)    65274.16 ( -17.04%)
BHmean-99 3-INCR           74404.76 (   0.00%)    68941.74 (  -7.34%)
BHmean-99 3-LPUSH          71816.15 (   0.00%)    59128.84 ( -17.67%)
BHmean-99 3-LPOP           69601.53 (   0.00%)    57249.18 ( -17.75%)
BHmean-99 3-SADD           66390.04 (   0.00%)    61050.06 (  -8.04%)
BHmean-99 3-SPOP           72912.87 (   0.00%)    56939.51 ( -21.91%)
BHmean-99 3-LRANGE_100     45372.05 (   0.00%)    35682.43 ( -21.36%)
BHmean-99 3-LRANGE_300     25070.51 (   0.00%)    20756.57 ( -17.21%)
BHmean-99 3-LRANGE_500     18990.65 (   0.00%)    13806.91 ( -27.30%)
BHmean-99 3-LRANGE_600     16237.06 (   0.00%)    12192.89 ( -24.91%)
BHmean-99 3-MSET-10        59853.36 (   0.00%)    43739.75 ( -26.92%)
BHmean-99 5-PING_INLINE    76074.55 (   0.00%)    59970.02 ( -21.17%)
BHmean-99 5-PING_BULK      79459.67 (   0.00%)    60661.21 ( -23.66%)
BHmean-99 5-SET            75714.56 (   0.00%)    60569.35 ( -20.00%)
BHmean-99 5-GET            80580.18 (   0.00%)    63471.91 ( -21.23%)
BHmean-99 5-INCR           77715.17 (   0.00%)    62617.41 ( -19.43%)
BHmean-99 5-LPUSH          76348.83 (   0.00%)    56775.17 ( -25.64%)
BHmean-99 5-LPOP           75829.39 (   0.00%)    66104.77 ( -12.82%)
BHmean-99 5-SADD           71658.90 (   0.00%)    63011.97 ( -12.07%)
BHmean-99 5-SPOP           75357.95 (   0.00%)    63231.11 ( -16.09%)
BHmean-99 5-LRANGE_100     50075.12 (   0.00%)    31809.15 ( -36.48%)
BHmean-99 5-LRANGE_300     26897.99 (   0.00%)    17633.57 ( -34.44%)
BHmean-99 5-LRANGE_500     20288.09 (   0.00%)    14387.97 ( -29.08%)
BHmean-99 5-LRANGE_600     17096.94 (   0.00%)    11413.57 ( -33.24%)
BHmean-99 5-MSET-10        65178.43 (   0.00%)    45563.28 ( -30.09%)
BHmean-99 7-PING_INLINE    75528.70 (   0.00%)    62735.26 ( -16.94%)
BHmean-99 7-PING_BULK      78817.73 (   0.00%)    65316.79 ( -17.13%)
BHmean-99 7-SET            76467.21 (   0.00%)    60159.42 ( -21.33%)
BHmean-99 7-GET            85233.33 (   0.00%)    60679.61 ( -28.81%)
BHmean-99 7-INCR           78354.55 (   0.00%)    60523.53 ( -22.76%)
BHmean-99 7-LPUSH          77626.36 (   0.00%)    62098.94 ( -20.00%)
BHmean-99 7-LPOP           77101.00 (   0.00%)    61087.35 ( -20.77%)
BHmean-99 7-SADD           79649.54 (   0.00%)    62421.97 ( -21.63%)
BHmean-99 7-SPOP           81799.59 (   0.00%)    70584.08 ( -13.71%)
BHmean-99 7-LRANGE_100     49327.91 (   0.00%)    41950.71 ( -14.96%)
BHmean-99 7-LRANGE_300     25743.34 (   0.00%)    17583.96 ( -31.70%)
BHmean-99 7-LRANGE_500     20420.67 (   0.00%)    12366.67 ( -39.44%)
BHmean-99 7-LRANGE_600     16820.86 (   0.00%)    10474.77 ( -37.73%)
BHmean-99 7-MSET-10        64526.54 (   0.00%)    50806.55 ( -21.26%)
BHmean-99 8-PING_INLINE    75187.97 (   0.00%)    60141.33 ( -20.01%)
BHmean-99 8-PING_BULK      78079.25 (   0.00%)    62992.12 ( -19.32%)
BHmean-99 8-SET            80080.08 (   0.00%)    59040.59 ( -26.27%)
BHmean-99 8-GET            81037.28 (   0.00%)    63775.51 ( -21.30%)
BHmean-99 8-INCR           75272.86 (   0.00%)    65767.84 ( -12.63%)
BHmean-99 8-LPUSH          79477.22 (   0.00%)    66074.44 ( -16.86%)
BHmean-99 8-LPOP           75485.94 (   0.00%)    65231.57 ( -13.58%)
BHmean-99 8-SADD           76908.29 (   0.00%)    59514.95 ( -22.62%)
BHmean-99 8-SPOP           83804.74 (   0.00%)    60295.45 ( -28.05%)
BHmean-99 8-LRANGE_100     45253.98 (   0.00%)    41262.64 (  -8.82%)
BHmean-99 8-LRANGE_300     23930.60 (   0.00%)    16881.20 ( -29.46%)
BHmean-99 8-LRANGE_500     17487.87 (   0.00%)    14352.35 ( -17.93%)
BHmean-99 8-LRANGE_600     14299.50 (   0.00%)    10096.68 ( -29.39%)
BHmean-99 8-MSET-10        62823.93 (   0.00%)    50479.56 ( -19.65%)
```

That is a lot of data. Most of the times, the first thing we want to
do is quickly checking the mean:

```
./bin/compare-mmtests.pl --directory work/log/ --names BASELINE,BUSY --benchmark redis | grep '^.mean'
Hmean     1-PING_INLINE    32419.12 (   0.00%)    24696.23 * -23.82%*
Hmean     1-PING_BULK      34690.90 (   0.00%)    27025.57 * -22.10%*
Hmean     1-SET            31788.42 (   0.00%)    26024.05 * -18.13%*
Hmean     1-GET            35343.18 (   0.00%)    26881.72 * -23.94%*
Hmean     1-INCR           36475.05 (   0.00%)    25729.43 * -29.46%*
Hmean     1-LPUSH          37181.63 (   0.00%)    27154.73 * -26.97%*
Hmean     1-LPOP           37271.71 (   0.00%)    27066.53 * -27.38%*
Hmean     1-SADD           35119.76 (   0.00%)    27802.49 * -20.84%*
Hmean     1-SPOP           36563.07 (   0.00%)    28428.47 * -22.25%*
Hmean     1-LRANGE_100     28137.31 (   0.00%)    18478.82 * -34.33%*
Hmean     1-LRANGE_300     15573.90 (   0.00%)    10530.31 * -32.38%*
Hmean     1-LRANGE_500     12717.79 (   0.00%)     8202.64 * -35.50%*
Hmean     1-LRANGE_600     10648.72 (   0.00%)     6504.91 * -38.91%*
Hmean     1-MSET-10        27135.57 (   0.00%)    22407.46 ( -17.42%)
Hmean     3-PING_INLINE    71541.00 (   0.00%)    55909.65 * -21.85%*
Hmean     3-PING_BULK      73464.59 (   0.00%)    56612.32 * -22.94%*
Hmean     3-SET            76359.19 (   0.00%)    59509.64 * -22.07%*
Hmean     3-GET            76300.93 (   0.00%)    59730.02 * -21.72%*
Hmean     3-INCR           73844.34 (   0.00%)    63848.80 ( -13.54%)
Hmean     3-LPUSH          71214.92 (   0.00%)    58407.80 * -17.98%*
Hmean     3-LPOP           68700.19 (   0.00%)    56471.65 * -17.80%*
Hmean     3-SADD           65189.05 (   0.00%)    58500.06 ( -10.26%)
Hmean     3-SPOP           71736.01 (   0.00%)    56167.15 * -21.70%*
Hmean     3-LRANGE_100     44839.03 (   0.00%)    35206.31 * -21.48%*
Hmean     3-LRANGE_300     24537.47 (   0.00%)    19947.34 * -18.71%*
Hmean     3-LRANGE_500     18830.98 (   0.00%)    12952.02 * -31.22%*
Hmean     3-LRANGE_600     16066.84 (   0.00%)    11180.18 * -30.41%*
Hmean     3-MSET-10        59192.61 (   0.00%)    42629.38 * -27.98%*
Hmean     5-PING_INLINE    75030.01 (   0.00%)    59616.07 * -20.54%*
Hmean     5-PING_BULK      77399.38 (   0.00%)    58241.12 * -24.75%*
Hmean     5-SET            74940.05 (   0.00%)    59171.60 * -21.04%*
Hmean     5-GET            79592.49 (   0.00%)    60753.34 * -23.67%*
Hmean     5-INCR           76781.32 (   0.00%)    61743.64 * -19.59%*
Hmean     5-LPUSH          75688.77 (   0.00%)    55784.89 * -26.30%*
Hmean     5-LPOP           74437.99 (   0.00%)    63979.52 * -14.05%*
Hmean     5-SADD           70422.54 (   0.00%)    61523.32 * -12.64%*
Hmean     5-SPOP           74327.34 (   0.00%)    62173.59 * -16.35%*
Hmean     5-LRANGE_100     48923.68 (   0.00%)    31371.57 * -35.88%*
Hmean     5-LRANGE_300     26481.65 (   0.00%)    16633.40 * -37.19%*
Hmean     5-LRANGE_500     20140.99 (   0.00%)    13207.60 * -34.42%*
Hmean     5-LRANGE_600     16959.50 (   0.00%)    10333.78 * -39.07%*
Hmean     5-MSET-10        63621.33 (   0.00%)    45008.55 * -29.26%*
Hmean     7-PING_INLINE    74604.59 (   0.00%)    61606.70 * -17.42%*
Hmean     7-PING_BULK      77006.00 (   0.00%)    63613.23 * -17.39%*
Hmean     7-SET            74827.90 (   0.00%)    58193.67 * -22.23%*
Hmean     7-GET            81579.38 (   0.00%)    58119.26 * -28.76%*
Hmean     7-INCR           76722.42 (   0.00%)    58851.22 * -23.29%*
Hmean     7-LPUSH          76417.55 (   0.00%)    60602.39 * -20.70%*
Hmean     7-LPOP           76840.33 (   0.00%)    59171.60 * -22.99%*
Hmean     7-SADD           78851.91 (   0.00%)    61251.99 * -22.32%*
Hmean     7-SPOP           80141.05 (   0.00%)    68643.60 * -14.35%*
Hmean     7-LRANGE_100     48899.76 (   0.00%)    39597.69 * -19.02%*
Hmean     7-LRANGE_300     25563.68 (   0.00%)    16927.92 * -33.78%*
Hmean     7-LRANGE_500     20000.80 (   0.00%)    11583.46 * -42.09%*
Hmean     7-LRANGE_600     16753.23 (   0.00%)     9661.65 * -42.33%*
Hmean     7-MSET-10        63669.94 (   0.00%)    48058.44 * -24.52%*
Hmean     8-PING_INLINE    73997.33 (   0.00%)    56876.35 * -23.14%*
Hmean     8-PING_BULK      75930.14 (   0.00%)    60598.71 * -20.19%*
Hmean     8-SET            79276.99 (   0.00%)    54692.63 * -31.01%*
Hmean     8-GET            78802.21 (   0.00%)    61515.75 * -21.94%*
Hmean     8-INCR           73616.02 (   0.00%)    61957.87 ( -15.84%)
Hmean     8-LPUSH          78462.14 (   0.00%)    62527.35 * -20.31%*
Hmean     8-LPOP           75018.75 (   0.00%)    63451.78 * -15.42%*
Hmean     8-SADD           76010.95 (   0.00%)    57570.52 * -24.26%*
Hmean     8-SPOP           82740.36 (   0.00%)    56439.78 * -31.79%*
Hmean     8-LRANGE_100     45020.71 (   0.00%)    38592.16 * -14.28%*
Hmean     8-LRANGE_300     23508.39 (   0.00%)    16026.16 * -31.83%*
Hmean     8-LRANGE_500     17094.60 (   0.00%)    13063.70 ( -23.58%)
Hmean     8-LRANGE_600     13959.07 (   0.00%)     9393.91 * -32.70%*
Hmean     8-MSET-10        61530.89 (   0.00%)    48657.07 * -20.92%*
```

Other things we can do with `compare-mmtests.pl`:

```
./bin/compare-mmtests.pl --directory work/log/ --names BASELINE,BUSY --benchmark redis --print-monitor duration
                    BASELINE        BUSY
Duration User         632.09      934.45
Duration System       762.86     1019.59
Duration Elapsed      975.82     1353.28
```

Also with `compare-mmtests.pl`, we can look at how the benchmarks went,
overall, by looking at the geometric mean:

```
test@localhost:~/mmtests> ./bin/compare-mmtests.pl --directory work/log/ --names BASELINE,BUSY --benchmark redis --print-ratio
                         BASELINE                   BUSY
Dmean Higher               0.00                    -3.12
Dmin  Higher               0.00                    -9.30
Dmax  Higher               0.00                    -0.96
Gmean Higher               1.00                     0.75
```

### Plain-Text Reporting with `compare-kernels.sh`

`compare-kernels.sh will, by default, produce the same tables as
`compare-mmtests.pl`, but will show the output from the monitors as well:

```
test@localhost:~/mmtests/work/log> ../../compare-kernels.sh
                                      BASELINE                   BUSY
Min       1-PING_INLINE    23201.86 (   0.00%)    22639.80 (  -2.42%)
Min       1-PING_BULK      24218.94 (   0.00%)    24467.83 (   1.03%)
Min       1-SET            23014.96 (   0.00%)    24207.21 (   5.18%)
Min       1-GET            32164.68 (   0.00%)    25081.52 ( -22.02%)
Min       1-INCR           35323.21 (   0.00%)    23148.15 ( -34.47%)
Min       1-LPUSH          35868.00 (   0.00%)    18145.53 ( -49.41%)
Min       1-LPOP           35511.36 (   0.00%)    24813.89 ( -30.12%)
Min       1-SADD           33704.08 (   0.00%)    24026.91 ( -28.71%)
Min       1-SPOP           34554.25 (   0.00%)    25667.35 ( -25.72%)
Min       1-LRANGE_100     24557.96 (   0.00%)    14144.27 ( -42.40%)
Min       1-LRANGE_300      9855.13 (   0.00%)     9405.57 (  -4.56%)
Min       1-LRANGE_500      8113.59 (   0.00%)     7163.32 ( -11.71%)
Min       1-LRANGE_600      6460.37 (   0.00%)     5621.45 ( -12.99%)
Min       1-MSET-10        19083.97 (   0.00%)    18389.11 (  -3.64%)
Min       3-PING_INLINE    67204.30 (   0.00%)    51733.06 ( -23.02%)
Min       3-PING_BULK      69541.03 (   0.00%)    52002.08 ( -25.22%)
Min       3-SET            68587.11 (   0.00%)    54347.82 ( -20.76%)
Min       3-GET            68073.52 (   0.00%)    44583.15 ( -34.51%)
Min       3-INCR           71684.59 (   0.00%)    49285.36 ( -31.25%)
Min       3-LPUSH          66225.16 (   0.00%)    52631.58 ( -20.53%)
Min       3-LPOP           65316.79 (   0.00%)    53561.86 ( -18.00%)
Min       3-SADD           60790.27 (   0.00%)    50125.31 ( -17.54%)
Min       3-SPOP           67385.45 (   0.00%)    53276.50 ( -20.94%)
Min       3-LRANGE_100     42826.55 (   0.00%)    33422.46 ( -21.96%)
Min       3-LRANGE_300     22614.20 (   0.00%)    17256.26 ( -23.69%)
Min       3-LRANGE_500     18218.26 (   0.00%)    10380.98 ( -43.02%)
Min       3-LRANGE_600     15420.20 (   0.00%)     8392.08 ( -45.58%)
Min       3-MSET-10        56689.34 (   0.00%)    38699.69 ( -31.73%)
Min       5-PING_INLINE    71123.76 (   0.00%)    58241.12 ( -18.11%)
Min       5-PING_BULK      70126.23 (   0.00%)    50226.02 ( -28.38%)
Min       5-SET            71994.23 (   0.00%)    54171.18 ( -24.76%)
Min       5-GET            75872.54 (   0.00%)    51867.22 ( -31.64%)
Min       5-INCR           73260.07 (   0.00%)    58479.53 ( -20.18%)
Min       5-LPUSH          70224.72 (   0.00%)    48216.01 ( -31.34%)
Min       5-LPOP           69348.12 (   0.00%)    56689.34 ( -18.25%)
Min       5-SADD           65876.16 (   0.00%)    56211.35 ( -14.67%)
Min       5-SPOP           70472.16 (   0.00%)    58275.06 ( -17.31%)
Min       5-LRANGE_100     44802.86 (   0.00%)    29735.36 ( -33.63%)
Min       5-LRANGE_300     24937.65 (   0.00%)    13557.48 ( -45.63%)
Min       5-LRANGE_500     19573.30 (   0.00%)     9944.31 ( -49.19%)
Min       5-LRANGE_600     16431.15 (   0.00%)     7496.81 ( -54.37%)
Min       5-MSET-10        58072.01 (   0.00%)    42918.46 ( -26.09%)
Min       7-PING_INLINE    71123.76 (   0.00%)    57471.27 ( -19.20%)
Min       7-PING_BULK      70521.86 (   0.00%)    57603.69 ( -18.32%)
Min       7-SET            68917.99 (   0.00%)    51466.80 ( -25.32%)
Min       7-GET            69637.88 (   0.00%)    49726.51 ( -28.59%)
Min       7-INCR           70821.53 (   0.00%)    52994.17 ( -25.17%)
Min       7-LPUSH          67024.13 (   0.00%)    49800.80 ( -25.70%)
Min       7-LPOP           75815.01 (   0.00%)    52576.24 ( -30.65%)
Min       7-SADD           75815.01 (   0.00%)    56980.06 ( -24.84%)
Min       7-SPOP           74128.98 (   0.00%)    61842.92 ( -16.57%)
Min       7-LRANGE_100     47258.98 (   0.00%)    32341.53 ( -31.57%)
Min       7-LRANGE_300     24869.44 (   0.00%)    14729.71 ( -40.77%)
Min       7-LRANGE_500     18480.87 (   0.00%)     9242.14 ( -49.99%)
Min       7-LRANGE_600     16488.05 (   0.00%)     7372.46 ( -55.29%)
Min       7-MSET-10        60459.49 (   0.00%)    39510.08 ( -34.65%)
Min       8-PING_INLINE    69589.42 (   0.00%)    46728.97 ( -32.85%)
Min       8-PING_BULK      68399.45 (   0.00%)    52603.89 ( -23.09%)
Min       8-SET            76219.51 (   0.00%)    42247.57 ( -44.57%)
Min       8-GET            70972.32 (   0.00%)    53879.31 ( -24.08%)
Min       8-INCR           67659.00 (   0.00%)    50301.81 ( -25.65%)
Min       8-LPUSH          70372.98 (   0.00%)    42158.52 ( -40.09%)
Min       8-LPOP           73206.44 (   0.00%)    57208.24 ( -21.85%)
Min       8-SADD           72621.64 (   0.00%)    50916.50 ( -29.89%)
Min       8-SPOP           78740.16 (   0.00%)    44943.82 ( -42.92%)
Min       8-LRANGE_100     44111.16 (   0.00%)    30656.04 ( -30.50%)
Min       8-LRANGE_300     21958.72 (   0.00%)    13326.23 ( -39.31%)
Min       8-LRANGE_500     15683.81 (   0.00%)     9611.69 ( -38.72%)
Min       8-LRANGE_600     12745.35 (   0.00%)     7348.08 ( -42.35%)
Min       8-MSET-10        56850.48 (   0.00%)    42517.01 ( -25.21%)
Hmean     1-PING_INLINE    32419.12 (   0.00%)    24696.23 * -23.82%*
Hmean     1-PING_BULK      34690.90 (   0.00%)    27025.57 * -22.10%*
Hmean     1-SET            31788.42 (   0.00%)    26024.05 * -18.13%*
Hmean     1-GET            35343.18 (   0.00%)    26881.72 * -23.94%*
Hmean     1-INCR           36475.05 (   0.00%)    25729.43 * -29.46%*
Hmean     1-LPUSH          37181.63 (   0.00%)    27154.73 * -26.97%*
Hmean     1-LPOP           37271.71 (   0.00%)    27066.53 * -27.38%*
Hmean     1-SADD           35119.76 (   0.00%)    27802.49 * -20.84%*
Hmean     1-SPOP           36563.07 (   0.00%)    28428.47 * -22.25%*
Hmean     1-LRANGE_100     28137.31 (   0.00%)    18478.82 * -34.33%*
Hmean     1-LRANGE_300     15573.90 (   0.00%)    10530.31 * -32.38%*
Hmean     1-LRANGE_500     12717.79 (   0.00%)     8202.64 * -35.50%*
Hmean     1-LRANGE_600     10648.72 (   0.00%)     6504.91 * -38.91%*
Hmean     1-MSET-10        27135.57 (   0.00%)    22407.46 ( -17.42%)
Hmean     3-PING_INLINE    71541.00 (   0.00%)    55909.65 * -21.85%*
Hmean     3-PING_BULK      73464.59 (   0.00%)    56612.32 * -22.94%*
Hmean     3-SET            76359.19 (   0.00%)    59509.64 * -22.07%*
Hmean     3-GET            76300.93 (   0.00%)    59730.02 * -21.72%*
Hmean     3-INCR           73844.34 (   0.00%)    63848.80 ( -13.54%)
Hmean     3-LPUSH          71214.92 (   0.00%)    58407.80 * -17.98%*
Hmean     3-LPOP           68700.19 (   0.00%)    56471.65 * -17.80%*
Hmean     3-SADD           65189.05 (   0.00%)    58500.06 ( -10.26%)
Hmean     3-SPOP           71736.01 (   0.00%)    56167.15 * -21.70%*
Hmean     3-LRANGE_100     44839.03 (   0.00%)    35206.31 * -21.48%*
Hmean     3-LRANGE_300     24537.47 (   0.00%)    19947.34 * -18.71%*
Hmean     3-LRANGE_500     18830.98 (   0.00%)    12952.02 * -31.22%*
Hmean     3-LRANGE_600     16066.84 (   0.00%)    11180.18 * -30.41%*
Hmean     3-MSET-10        59192.61 (   0.00%)    42629.38 * -27.98%*
Hmean     5-PING_INLINE    75030.01 (   0.00%)    59616.07 * -20.54%*
Hmean     5-PING_BULK      77399.38 (   0.00%)    58241.12 * -24.75%*
Hmean     5-SET            74940.05 (   0.00%)    59171.60 * -21.04%*
Hmean     5-GET            79592.49 (   0.00%)    60753.34 * -23.67%*
Hmean     5-INCR           76781.32 (   0.00%)    61743.64 * -19.59%*
Hmean     5-LPUSH          75688.77 (   0.00%)    55784.89 * -26.30%*
Hmean     5-LPOP           74437.99 (   0.00%)    63979.52 * -14.05%*
Hmean     5-SADD           70422.54 (   0.00%)    61523.32 * -12.64%*
Hmean     5-SPOP           74327.34 (   0.00%)    62173.59 * -16.35%*
Hmean     5-LRANGE_100     48923.68 (   0.00%)    31371.57 * -35.88%*
Hmean     5-LRANGE_300     26481.65 (   0.00%)    16633.40 * -37.19%*
Hmean     5-LRANGE_500     20140.99 (   0.00%)    13207.60 * -34.42%*
Hmean     5-LRANGE_600     16959.50 (   0.00%)    10333.78 * -39.07%*
Hmean     5-MSET-10        63621.33 (   0.00%)    45008.55 * -29.26%*
Hmean     7-PING_INLINE    74604.59 (   0.00%)    61606.70 * -17.42%*
Hmean     7-PING_BULK      77006.00 (   0.00%)    63613.23 * -17.39%*
Hmean     7-SET            74827.90 (   0.00%)    58193.67 * -22.23%*
Hmean     7-GET            81579.38 (   0.00%)    58119.26 * -28.76%*
Hmean     7-INCR           76722.42 (   0.00%)    58851.22 * -23.29%*
Hmean     7-LPUSH          76417.55 (   0.00%)    60602.39 * -20.70%*
Hmean     7-LPOP           76840.33 (   0.00%)    59171.60 * -22.99%*
Hmean     7-SADD           78851.91 (   0.00%)    61251.99 * -22.32%*
Hmean     7-SPOP           80141.05 (   0.00%)    68643.60 * -14.35%*
Hmean     7-LRANGE_100     48899.76 (   0.00%)    39597.69 * -19.02%*
Hmean     7-LRANGE_300     25563.68 (   0.00%)    16927.92 * -33.78%*
Hmean     7-LRANGE_500     20000.80 (   0.00%)    11583.46 * -42.09%*
Hmean     7-LRANGE_600     16753.23 (   0.00%)     9661.65 * -42.33%*
Hmean     7-MSET-10        63669.94 (   0.00%)    48058.44 * -24.52%*
Hmean     8-PING_INLINE    73997.33 (   0.00%)    56876.35 * -23.14%*
Hmean     8-PING_BULK      75930.14 (   0.00%)    60598.71 * -20.19%*
Hmean     8-SET            79276.99 (   0.00%)    54692.63 * -31.01%*
Hmean     8-GET            78802.21 (   0.00%)    61515.75 * -21.94%*
Hmean     8-INCR           73616.02 (   0.00%)    61957.87 ( -15.84%)
Hmean     8-LPUSH          78462.14 (   0.00%)    62527.35 * -20.31%*
Hmean     8-LPOP           75018.75 (   0.00%)    63451.78 * -15.42%*
Hmean     8-SADD           76010.95 (   0.00%)    57570.52 * -24.26%*
Hmean     8-SPOP           82740.36 (   0.00%)    56439.78 * -31.79%*
Hmean     8-LRANGE_100     45020.71 (   0.00%)    38592.16 * -14.28%*
Hmean     8-LRANGE_300     23508.39 (   0.00%)    16026.16 * -31.83%*
Hmean     8-LRANGE_500     17094.60 (   0.00%)    13063.70 ( -23.58%)
Hmean     8-LRANGE_600     13959.07 (   0.00%)     9393.91 * -32.70%*
Hmean     8-MSET-10        61530.89 (   0.00%)    48657.07 * -20.92%*
Stddev    1-PING_INLINE     5829.00 (   0.00%)     1328.39 (  77.21%)
Stddev    1-PING_BULK       6692.90 (   0.00%)     3403.57 (  49.15%)
Stddev    1-SET             5573.04 (   0.00%)     2313.88 (  58.48%)
Stddev    1-GET             2256.62 (   0.00%)     2016.66 (  10.63%)
Stddev    1-INCR            1711.89 (   0.00%)     2953.87 ( -72.55%)
Stddev    1-LPUSH           1047.81 (   0.00%)     4756.49 (-353.94%)
Stddev    1-LPOP            1299.04 (   0.00%)     2747.40 (-111.50%)
Stddev    1-SADD            1665.78 (   0.00%)     3971.27 (-138.40%)
Stddev    1-SPOP            1418.56 (   0.00%)     3242.17 (-128.55%)
Stddev    1-LRANGE_100      2214.50 (   0.00%)     3230.29 ( -45.87%)
Stddev    1-LRANGE_300      3796.07 (   0.00%)     1189.79 (  68.66%)
Stddev    1-LRANGE_500      3076.94 (   0.00%)     1599.39 (  48.02%)
Stddev    1-LRANGE_600      2892.27 (   0.00%)     1069.36 (  63.03%)
Stddev    1-MSET-10         5603.16 (   0.00%)     4130.64 (  26.28%)
Stddev    3-PING_INLINE     3628.76 (   0.00%)     3349.65 (   7.69%)
Stddev    3-PING_BULK       2632.70 (   0.00%)     6238.77 (-136.97%)
Stddev    3-SET             7167.93 (   0.00%)     4955.92 (  30.86%)
Stddev    3-GET             6605.67 (   0.00%)    15329.78 (-132.07%)
Stddev    3-INCR            2925.69 (   0.00%)    12262.04 (-319.12%)
Stddev    3-LPUSH           3896.81 (   0.00%)     4523.32 ( -16.08%)
Stddev    3-LPOP            4704.39 (   0.00%)     2993.29 (  36.37%)
Stddev    3-SADD            3323.46 (   0.00%)     7584.83 (-128.22%)
Stddev    3-SPOP            4487.28 (   0.00%)     2274.98 (  49.30%)
Stddev    3-LRANGE_100      2671.44 (   0.00%)     1417.94 (  46.92%)
Stddev    3-LRANGE_300      1293.61 (   0.00%)     3032.13 (-134.39%)
Stddev    3-LRANGE_500       478.40 (   0.00%)     2307.10 (-382.25%)
Stddev    3-LRANGE_600       392.88 (   0.00%)     3441.95 (-776.08%)
Stddev    3-MSET-10         3753.46 (   0.00%)     4323.20 ( -15.18%)
Stddev    5-PING_INLINE     4680.72 (   0.00%)     1022.35 (  78.16%)
Stddev    5-PING_BULK       6782.40 (   0.00%)     5061.65 (  25.37%)
Stddev    5-SET             2207.38 (   0.00%)     3090.58 ( -40.01%)
Stddev    5-GET             3464.36 (   0.00%)     9509.11 (-174.48%)
Stddev    5-INCR            3437.23 (   0.00%)     2990.64 (  12.99%)
Stddev    5-LPUSH           3732.69 (   0.00%)     4540.13 ( -21.63%)
Stddev    5-LPOP            3911.23 (   0.00%)    11868.13 (-203.44%)
Stddev    5-SADD            3688.33 (   0.00%)     3180.78 (  13.76%)
Stddev    5-SPOP            5843.11 (   0.00%)     3252.60 (  44.33%)
Stddev    5-LRANGE_100      2385.03 (   0.00%)     1200.19 (  49.68%)
Stddev    5-LRANGE_300      1453.23 (   0.00%)     1880.46 ( -29.40%)
Stddev    5-LRANGE_500       797.91 (   0.00%)     3276.04 (-310.58%)
Stddev    5-LRANGE_600       335.94 (   0.00%)     3987.61 (-1086.99%)
Stddev    5-MSET-10         3191.56 (   0.00%)     2269.08 (  28.90%)
Stddev    7-PING_INLINE     4213.42 (   0.00%)     3822.36 (   9.28%)
Stddev    7-PING_BULK       4326.00 (   0.00%)     7052.75 ( -63.03%)
Stddev    7-SET             5306.78 (   0.00%)     4404.63 (  17.00%)
Stddev    7-GET             9504.29 (   0.00%)     8276.54 (  12.92%)
Stddev    7-INCR            3846.92 (   0.00%)     3962.99 (  -3.02%)
Stddev    7-LPUSH           7850.05 (   0.00%)     7701.19 (   1.90%)
Stddev    7-LPOP            1259.06 (   0.00%)     4544.95 (-260.98%)
Stddev    7-SADD            2215.20 (   0.00%)     2870.54 ( -29.58%)
Stddev    7-SPOP            4483.64 (   0.00%)     8989.24 (-100.49%)
Stddev    7-LRANGE_100      2049.66 (   0.00%)     7785.56 (-279.85%)
Stddev    7-LRANGE_300       560.41 (   0.00%)     1966.17 (-250.85%)
Stddev    7-LRANGE_500       958.41 (   0.00%)     2070.11 (-115.99%)
Stddev    7-LRANGE_600       464.48 (   0.00%)     3035.06 (-553.43%)
Stddev    7-MSET-10         2506.20 (   0.00%)    15264.54 (-509.07%)
Stddev    8-PING_INLINE     3188.70 (   0.00%)     7632.60 (-139.36%)
Stddev    8-PING_BULK       7780.01 (   0.00%)     8742.50 ( -12.37%)
Stddev    8-SET             2916.77 (   0.00%)     8392.44 (-187.73%)
Stddev    8-GET             5805.48 (   0.00%)     6809.48 ( -17.29%)
Stddev    8-INCR            6406.50 (   0.00%)    14642.07 (-128.55%)
Stddev    8-LPUSH           6192.70 (   0.00%)    17725.61 (-186.23%)
Stddev    8-LPOP            2680.17 (   0.00%)     8054.31 (-200.51%)
Stddev    8-SADD            2198.62 (   0.00%)     7231.05 (-228.89%)
Stddev    8-SPOP            3384.00 (   0.00%)     7910.13 (-133.75%)
Stddev    8-LRANGE_100       859.97 (   0.00%)     7600.91 (-783.85%)
Stddev    8-LRANGE_300      1512.85 (   0.00%)     4270.56 (-182.29%)
Stddev    8-LRANGE_500      1367.87 (   0.00%)     5152.22 (-276.66%)
Stddev    8-LRANGE_600      1090.95 (   0.00%)     3140.45 (-187.86%)
Stddev    8-MSET-10         3842.50 (   0.00%)     5966.88 ( -55.29%)
CoeffVar  1-PING_INLINE       17.42 (   0.00%)        5.37 (  69.20%)
CoeffVar  1-PING_BULK         18.60 (   0.00%)       12.45 (  33.08%)
CoeffVar  1-SET               17.02 (   0.00%)        8.84 (  48.07%)
CoeffVar  1-GET                6.36 (   0.00%)        7.47 ( -17.36%)
CoeffVar  1-INCR               4.69 (   0.00%)       11.37 (-142.63%)
CoeffVar  1-LPUSH              2.82 (   0.00%)       16.98 (-503.08%)
CoeffVar  1-LPOP               3.48 (   0.00%)       10.07 (-189.22%)
CoeffVar  1-SADD               4.74 (   0.00%)       14.06 (-196.92%)
CoeffVar  1-SPOP               3.88 (   0.00%)       11.29 (-191.36%)
CoeffVar  1-LRANGE_100         7.83 (   0.00%)       17.03 (-117.53%)
CoeffVar  1-LRANGE_300        22.92 (   0.00%)       11.19 (  51.20%)
CoeffVar  1-LRANGE_500        22.79 (   0.00%)       19.02 (  16.56%)
CoeffVar  1-LRANGE_600        25.17 (   0.00%)       16.11 (  35.99%)
CoeffVar  1-MSET-10           19.85 (   0.00%)       17.98 (   9.43%)
CoeffVar  3-PING_INLINE        5.06 (   0.00%)        5.97 ( -18.02%)
CoeffVar  3-PING_BULK          3.58 (   0.00%)       10.93 (-205.18%)
CoeffVar  3-SET                9.32 (   0.00%)        8.28 (  11.12%)
CoeffVar  3-GET                8.61 (   0.00%)       24.46 (-184.21%)
CoeffVar  3-INCR               3.96 (   0.00%)       18.63 (-370.88%)
CoeffVar  3-LPUSH              5.46 (   0.00%)        7.71 ( -41.20%)
CoeffVar  3-LPOP               6.82 (   0.00%)        5.29 (  22.49%)
CoeffVar  3-SADD               5.09 (   0.00%)       12.80 (-151.64%)
CoeffVar  3-SPOP               6.24 (   0.00%)        4.05 (  35.14%)
CoeffVar  3-LRANGE_100         5.94 (   0.00%)        4.02 (  32.31%)
CoeffVar  3-LRANGE_300         5.26 (   0.00%)       14.96 (-184.38%)
CoeffVar  3-LRANGE_500         2.54 (   0.00%)       17.37 (-583.97%)
CoeffVar  3-LRANGE_600         2.44 (   0.00%)       28.72 (-1075.02%)
CoeffVar  3-MSET-10            6.32 (   0.00%)       10.06 ( -59.18%)
CoeffVar  5-PING_INLINE        6.22 (   0.00%)        1.71 (  72.43%)
CoeffVar  5-PING_BULK          8.71 (   0.00%)        8.63 (   0.89%)
CoeffVar  5-SET                2.94 (   0.00%)        5.21 ( -77.04%)
CoeffVar  5-GET                4.35 (   0.00%)       15.38 (-253.93%)
CoeffVar  5-INCR               4.47 (   0.00%)        4.83 (  -8.17%)
CoeffVar  5-LPUSH              4.92 (   0.00%)        8.09 ( -64.41%)
CoeffVar  5-LPOP               5.24 (   0.00%)       18.15 (-246.15%)
CoeffVar  5-SADD               5.23 (   0.00%)        5.16 (   1.29%)
CoeffVar  5-SPOP               7.83 (   0.00%)        5.22 (  33.30%)
CoeffVar  5-LRANGE_100         4.87 (   0.00%)        3.82 (  21.46%)
CoeffVar  5-LRANGE_300         5.47 (   0.00%)       11.17 (-104.12%)
CoeffVar  5-LRANGE_500         3.96 (   0.00%)       23.70 (-498.94%)
CoeffVar  5-LRANGE_600         1.98 (   0.00%)       34.98 (-1666.37%)
CoeffVar  5-MSET-10            5.01 (   0.00%)        5.03 (  -0.51%)
CoeffVar  7-PING_INLINE        5.63 (   0.00%)        6.19 (  -9.80%)
CoeffVar  7-PING_BULK          5.60 (   0.00%)       10.98 ( -96.02%)
CoeffVar  7-SET                7.06 (   0.00%)        7.53 (  -6.62%)
CoeffVar  7-GET               11.53 (   0.00%)       14.02 ( -21.65%)
CoeffVar  7-INCR               5.00 (   0.00%)        6.71 ( -34.07%)
CoeffVar  7-LPUSH             10.18 (   0.00%)       12.54 ( -23.19%)
CoeffVar  7-LPOP               1.64 (   0.00%)        7.64 (-366.57%)
CoeffVar  7-SADD               2.81 (   0.00%)        4.68 ( -66.62%)
CoeffVar  7-SPOP               5.58 (   0.00%)       12.93 (-131.74%)
CoeffVar  7-LRANGE_100         4.19 (   0.00%)       19.06 (-355.40%)
CoeffVar  7-LRANGE_300         2.19 (   0.00%)       11.49 (-424.32%)
CoeffVar  7-LRANGE_500         4.78 (   0.00%)       17.42 (-264.27%)
CoeffVar  7-LRANGE_600         2.77 (   0.00%)       29.64 (-969.65%)
CoeffVar  7-MSET-10            3.93 (   0.00%)       30.05 (-664.35%)
CoeffVar  8-PING_INLINE        4.30 (   0.00%)       13.22 (-207.34%)
CoeffVar  8-PING_BULK         10.16 (   0.00%)       14.20 ( -39.68%)
CoeffVar  8-SET                3.68 (   0.00%)       15.03 (-308.84%)
CoeffVar  8-GET                7.33 (   0.00%)       10.97 ( -49.54%)
CoeffVar  8-INCR               8.65 (   0.00%)       22.81 (-163.68%)
CoeffVar  8-LPUSH              7.85 (   0.00%)       26.77 (-241.02%)
CoeffVar  8-LPOP               3.57 (   0.00%)       12.54 (-251.35%)
CoeffVar  8-SADD               2.89 (   0.00%)       12.41 (-329.40%)
CoeffVar  8-SPOP               4.08 (   0.00%)       13.78 (-237.33%)
CoeffVar  8-LRANGE_100         1.91 (   0.00%)       19.14 (-902.54%)
CoeffVar  8-LRANGE_300         6.41 (   0.00%)       25.48 (-297.23%)
CoeffVar  8-LRANGE_500         7.96 (   0.00%)       36.27 (-355.50%)
CoeffVar  8-LRANGE_600         7.78 (   0.00%)       31.03 (-298.99%)
CoeffVar  8-MSET-10            6.23 (   0.00%)       12.13 ( -94.79%)
Max       1-PING_INLINE    37835.79 (   0.00%)    26329.65 ( -30.41%)
Max       1-PING_BULK      40683.48 (   0.00%)    31786.40 ( -21.87%)
Max       1-SET            36603.22 (   0.00%)    29299.74 ( -19.95%)
Max       1-GET            38270.19 (   0.00%)    29103.61 ( -23.95%)
Max       1-INCR           39541.32 (   0.00%)    30469.22 ( -22.94%)
Max       1-LPUSH          39541.32 (   0.00%)    34674.06 ( -12.31%)
Max       1-LPOP           38654.81 (   0.00%)    30769.23 ( -20.40%)
Max       1-SADD           38022.81 (   0.00%)    32851.51 ( -13.60%)
Max       1-SPOP           38535.64 (   0.00%)    32478.08 ( -15.72%)
Max       1-LRANGE_100     30422.88 (   0.00%)    22232.10 ( -26.92%)
Max       1-LRANGE_300     18942.98 (   0.00%)    11920.37 ( -37.07%)
Max       1-LRANGE_500     15915.96 (   0.00%)    11100.01 ( -30.26%)
Max       1-LRANGE_600     13489.82 (   0.00%)     7987.86 ( -40.79%)
Max       1-MSET-10        32927.23 (   0.00%)    28473.80 ( -13.53%)
Max       3-PING_INLINE    75872.54 (   0.00%)    60642.81 ( -20.07%)
Max       3-PING_BULK      76511.09 (   0.00%)    67704.80 ( -11.51%)
Max       3-SET            84459.46 (   0.00%)    67159.17 ( -20.48%)
Max       3-GET            86058.52 (   0.00%)    83542.19 (  -2.92%)
Max       3-INCR           78926.60 (   0.00%)    78926.60 (   0.00%)
Max       3-LPUSH          78492.93 (   0.00%)    69783.67 ( -11.10%)
Max       3-LPOP           76569.68 (   0.00%)    60496.07 ( -20.99%)
Max       3-SADD           69881.20 (   0.00%)    70871.72 (   1.42%)
Max       3-SPOP           78616.35 (   0.00%)    58823.53 ( -25.18%)
Max       3-LRANGE_100     49603.17 (   0.00%)    36724.20 ( -25.96%)
Max       3-LRANGE_300     26157.47 (   0.00%)    25361.40 (  -3.04%)
Max       3-LRANGE_500     19493.18 (   0.00%)    16092.69 ( -17.44%)
Max       3-LRANGE_600     16452.78 (   0.00%)    15807.78 (  -3.92%)
Max       3-MSET-10        65963.06 (   0.00%)    49726.51 ( -24.61%)
Max       5-PING_INLINE    82101.80 (   0.00%)    60827.25 ( -25.91%)
Max       5-PING_BULK      88573.96 (   0.00%)    63938.62 ( -27.81%)
Max       5-SET            77459.34 (   0.00%)    62034.74 ( -19.91%)
Max       5-GET            84175.09 (   0.00%)    77220.08 (  -8.26%)
Max       5-INCR           81103.00 (   0.00%)    65019.51 ( -19.83%)
Max       5-LPUSH          80775.45 (   0.00%)    62853.55 ( -22.19%)
Max       5-LPOP           80385.85 (   0.00%)    86281.27 (   7.33%)
Max       5-SADD           74515.65 (   0.00%)    63979.53 ( -14.14%)
Max       5-SPOP           84889.65 (   0.00%)    67204.30 ( -20.83%)
Max       5-LRANGE_100     50454.09 (   0.00%)    32797.64 ( -35.00%)
Max       5-LRANGE_300     28344.67 (   0.00%)    17979.14 ( -36.57%)
Max       5-LRANGE_500     21331.06 (   0.00%)    17605.63 ( -17.46%)
Max       5-LRANGE_600     17283.10 (   0.00%)    15807.78 (  -8.54%)
Max       5-MSET-10        65487.89 (   0.00%)    47824.00 ( -26.97%)
Max       7-PING_INLINE    81833.06 (   0.00%)    67750.68 ( -17.21%)
Max       7-PING_BULK      81300.81 (   0.00%)    72254.34 ( -11.13%)
Max       7-SET            83194.67 (   0.00%)    62266.50 ( -25.16%)
Max       7-GET            96153.85 (   0.00%)    70771.41 ( -26.40%)
Max       7-INCR           80580.17 (   0.00%)    62539.09 ( -22.39%)
Max       7-LPUSH          89445.44 (   0.00%)    78740.16 ( -11.97%)
Max       7-LPOP           78926.60 (   0.00%)    64143.68 ( -18.73%)
Max       7-SADD           81103.00 (   0.00%)    64599.48 ( -20.35%)
Max       7-SPOP           85689.80 (   0.00%)    82918.74 (  -3.23%)
Max       7-LRANGE_100     51572.98 (   0.00%)    49236.83 (  -4.53%)
Max       7-LRANGE_300     26136.96 (   0.00%)    19047.62 ( -27.12%)
Max       7-LRANGE_500     20898.64 (   0.00%)    14432.10 ( -30.94%)
Max       7-LRANGE_600     17587.06 (   0.00%)    15389.35 ( -12.50%)
Max       7-MSET-10        66137.57 (   0.00%)    77519.38 (  17.21%)
Max       8-PING_INLINE    78554.59 (   0.00%)    67842.61 ( -13.64%)
Max       8-PING_BULK      86956.52 (   0.00%)    72886.30 ( -16.18%)
Max       8-SET            83963.05 (   0.00%)    63051.70 ( -24.91%)
Max       8-GET            85178.88 (   0.00%)    72780.20 ( -14.56%)
Max       8-INCR           80906.16 (   0.00%)    89047.20 (  10.06%)
Max       8-LPUSH          91996.32 (   0.00%)   104821.80 (  13.94%)
Max       8-LPOP           79744.82 (   0.00%)    73855.24 (  -7.39%)
Max       8-SADD           77881.62 (   0.00%)    68073.52 ( -12.59%)
Max       8-SPOP           88105.73 (   0.00%)    65104.17 ( -26.11%)
Max       8-LRANGE_100     46274.87 (   0.00%)    51098.62 (  10.42%)
Max       8-LRANGE_300     25380.71 (   0.00%)    23691.07 (  -6.66%)
Max       8-LRANGE_500     19425.02 (   0.00%)    22988.51 (  18.34%)
Max       8-LRANGE_600     15610.37 (   0.00%)    13894.68 ( -10.99%)
Max       8-MSET-10        65487.89 (   0.00%)    58411.21 ( -10.81%)
BHmean-50 1-PING_INLINE    36630.04 (   0.00%)    25644.31 ( -29.99%)
BHmean-50 1-PING_BULK      40064.10 (   0.00%)    30983.74 ( -22.66%)
BHmean-50 1-SET            36016.57 (   0.00%)    28628.69 ( -20.51%)
BHmean-50 1-GET            37425.15 (   0.00%)    29103.61 ( -22.24%)
BHmean-50 1-INCR           37800.04 (   0.00%)    28801.84 ( -23.80%)
BHmean-50 1-LPUSH          37910.38 (   0.00%)    31265.63 ( -17.53%)
BHmean-50 1-LPOP           38417.21 (   0.00%)    30156.81 ( -21.50%)
BHmean-50 1-SADD           36489.69 (   0.00%)    32247.66 ( -11.63%)
BHmean-50 1-SPOP           37693.18 (   0.00%)    32107.88 ( -14.82%)
BHmean-50 1-LRANGE_100     29832.94 (   0.00%)    21706.10 ( -27.24%)
BHmean-50 1-LRANGE_300     18677.62 (   0.00%)    11836.42 ( -36.63%)
BHmean-50 1-LRANGE_500     15284.68 (   0.00%)     9684.29 ( -36.64%)
BHmean-50 1-LRANGE_600     13278.45 (   0.00%)     7772.12 ( -41.47%)
BHmean-50 1-MSET-10        32175.03 (   0.00%)    27173.91 ( -15.54%)
BHmean-50 3-PING_INLINE    75244.55 (   0.00%)    59136.60 ( -21.41%)
BHmean-50 3-PING_BULK      75642.96 (   0.00%)    61519.53 ( -18.67%)
BHmean-50 3-SET            83333.33 (   0.00%)    64578.62 ( -22.51%)
BHmean-50 3-GET            82610.49 (   0.00%)    77309.63 (  -6.42%)
BHmean-50 3-INCR           76161.46 (   0.00%)    76834.42 (   0.88%)
BHmean-50 3-LPUSH          74172.97 (   0.00%)    61334.64 ( -17.31%)
BHmean-50 3-LPOP           73367.57 (   0.00%)    59154.10 ( -19.37%)
BHmean-50 3-SADD           68166.33 (   0.00%)    65466.45 (  -3.96%)
BHmean-50 3-SPOP           75958.98 (   0.00%)    58224.16 ( -23.35%)
BHmean-50 3-LRANGE_100     46915.32 (   0.00%)    36683.79 ( -21.81%)
BHmean-50 3-LRANGE_300     25581.99 (   0.00%)    22386.39 ( -12.49%)
BHmean-50 3-LRANGE_500     19241.87 (   0.00%)    15205.66 ( -20.98%)
BHmean-50 3-LRANGE_600     16367.95 (   0.00%)    15384.62 (  -6.01%)
BHmean-50 3-MSET-10        62053.99 (   0.00%)    46360.69 ( -25.29%)
BHmean-50 5-PING_INLINE    79968.01 (   0.00%)    60459.49 ( -24.40%)
BHmean-50 5-PING_BULK      83437.63 (   0.00%)    61977.07 ( -25.72%)
BHmean-50 5-SET            76775.43 (   0.00%)    61576.35 ( -19.80%)
BHmean-50 5-GET            82987.55 (   0.00%)    68634.18 ( -17.30%)
BHmean-50 5-INCR           80256.82 (   0.00%)    65019.51 ( -18.99%)
BHmean-50 5-LPUSH          78926.60 (   0.00%)    59566.36 ( -24.53%)
BHmean-50 5-LPOP           77369.44 (   0.00%)    72463.76 (  -6.34%)
BHmean-50 5-SADD           74019.24 (   0.00%)    63816.21 ( -13.78%)
BHmean-50 5-SPOP           78709.17 (   0.00%)    64956.15 ( -17.47%)
BHmean-50 5-LRANGE_100     50377.83 (   0.00%)    32520.32 ( -35.45%)
BHmean-50 5-LRANGE_300     27960.30 (   0.00%)    17969.45 ( -35.73%)
BHmean-50 5-LRANGE_500     20995.17 (   0.00%)    17226.53 ( -17.95%)
BHmean-50 5-LRANGE_600     17219.11 (   0.00%)    15605.49 (  -9.37%)
BHmean-50 5-MSET-10        65445.03 (   0.00%)    47460.84 ( -27.48%)
BHmean-50 7-PING_INLINE    78155.53 (   0.00%)    65125.36 ( -16.67%)
BHmean-50 7-PING_BULK      80612.65 (   0.00%)    71813.29 ( -10.92%)
BHmean-50 7-SET            79776.63 (   0.00%)    61804.70 ( -22.53%)
BHmean-50 7-GET            89887.64 (   0.00%)    66247.10 ( -26.30%)
BHmean-50 7-INCR           79936.05 (   0.00%)    62363.58 ( -21.98%)
BHmean-50 7-LPUSH          83752.09 (   0.00%)    65694.39 ( -21.56%)
BHmean-50 7-LPOP           77881.62 (   0.00%)    63251.11 ( -18.79%)
BHmean-50 7-SADD           81037.28 (   0.00%)    63593.00 ( -21.53%)
BHmean-50 7-SPOP           83927.82 (   0.00%)    78523.76 (  -6.44%)
BHmean-50 7-LRANGE_100     51177.07 (   0.00%)    47314.88 (  -7.55%)
BHmean-50 7-LRANGE_300     26126.72 (   0.00%)    18986.14 ( -27.33%)
BHmean-50 7-LRANGE_500     20733.98 (   0.00%)    13647.22 ( -34.18%)
BHmean-50 7-LRANGE_600     17099.86 (   0.00%)    12105.80 ( -29.21%)
BHmean-50 7-MSET-10        65963.07 (   0.00%)    59189.11 ( -10.27%)
BHmean-50 8-PING_INLINE    76569.68 (   0.00%)    63836.58 ( -16.63%)
BHmean-50 8-PING_BULK      84423.80 (   0.00%)    69881.20 ( -17.23%)
BHmean-50 8-SET            81933.63 (   0.00%)    62774.64 ( -23.38%)
BHmean-50 8-GET            84139.67 (   0.00%)    67024.13 ( -20.34%)
BHmean-50 8-INCR           80742.84 (   0.00%)    73448.40 (  -9.03%)
BHmean-50 8-LPUSH          82754.06 (   0.00%)    74128.98 ( -10.42%)
BHmean-50 8-LPOP           77279.75 (   0.00%)    72939.46 (  -5.62%)
BHmean-50 8-SADD           77790.74 (   0.00%)    65746.22 ( -15.48%)
BHmean-50 8-SPOP           85506.63 (   0.00%)    64184.85 ( -24.94%)
BHmean-50 8-LRANGE_100     45798.03 (   0.00%)    46296.30 (   1.09%)
BHmean-50 8-LRANGE_300     25176.23 (   0.00%)    20358.31 ( -19.14%)
BHmean-50 8-LRANGE_500     18137.30 (   0.00%)    17383.75 (  -4.15%)
BHmean-50 8-LRANGE_600     14984.65 (   0.00%)    13458.05 ( -10.19%)
BHmean-50 8-MSET-10        64913.99 (   0.00%)    53879.31 ( -17.00%)
BHmean-95 1-PING_INLINE    35993.88 (   0.00%)    25270.07 ( -29.79%)
BHmean-95 1-PING_BULK      38895.37 (   0.00%)    27750.80 ( -28.65%)
BHmean-95 1-SET            35137.04 (   0.00%)    26521.69 ( -24.52%)
BHmean-95 1-GET            36238.45 (   0.00%)    27372.89 ( -24.46%)
BHmean-95 1-INCR           36774.85 (   0.00%)    26467.28 ( -28.03%)
BHmean-95 1-LPUSH          37333.55 (   0.00%)    28740.22 ( -23.02%)
BHmean-95 1-LPOP           37739.41 (   0.00%)    27695.08 ( -26.61%)
BHmean-95 1-SADD           35492.46 (   0.00%)    28939.37 ( -18.46%)
BHmean-95 1-SPOP           37102.31 (   0.00%)    29214.14 ( -21.26%)
BHmean-95 1-LRANGE_100     29201.35 (   0.00%)    20012.01 ( -31.47%)
BHmean-95 1-LRANGE_300     18216.60 (   0.00%)    10854.82 ( -40.41%)
BHmean-95 1-LRANGE_500     14820.30 (   0.00%)     8511.36 ( -42.57%)
BHmean-95 1-LRANGE_600     12708.50 (   0.00%)     6770.94 ( -46.72%)
BHmean-95 1-MSET-10        30335.20 (   0.00%)    23702.30 ( -21.87%)
BHmean-95 3-PING_INLINE    72714.06 (   0.00%)    57061.34 ( -21.53%)
BHmean-95 3-PING_BULK      74515.65 (   0.00%)    57895.50 ( -22.30%)
BHmean-95 3-SET            78585.46 (   0.00%)    60957.03 ( -22.43%)
BHmean-95 3-GET            78678.21 (   0.00%)    65274.16 ( -17.04%)
BHmean-95 3-INCR           74404.76 (   0.00%)    68941.74 (  -7.34%)
BHmean-95 3-LPUSH          71816.15 (   0.00%)    59128.84 ( -17.67%)
BHmean-95 3-LPOP           69601.53 (   0.00%)    57249.18 ( -17.75%)
BHmean-95 3-SADD           66390.04 (   0.00%)    61050.06 (  -8.04%)
BHmean-95 3-SPOP           72912.87 (   0.00%)    56939.51 ( -21.91%)
BHmean-95 3-LRANGE_100     45372.05 (   0.00%)    35682.43 ( -21.36%)
BHmean-95 3-LRANGE_300     25070.51 (   0.00%)    20756.57 ( -17.21%)
BHmean-95 3-LRANGE_500     18990.65 (   0.00%)    13806.91 ( -27.30%)
BHmean-95 3-LRANGE_600     16237.06 (   0.00%)    12192.89 ( -24.91%)
BHmean-95 3-MSET-10        59853.36 (   0.00%)    43739.75 ( -26.92%)
BHmean-95 5-PING_INLINE    76074.55 (   0.00%)    59970.02 ( -21.17%)
BHmean-95 5-PING_BULK      79459.67 (   0.00%)    60661.21 ( -23.66%)
BHmean-95 5-SET            75714.56 (   0.00%)    60569.35 ( -20.00%)
BHmean-95 5-GET            80580.18 (   0.00%)    63471.91 ( -21.23%)
BHmean-95 5-INCR           77715.17 (   0.00%)    62617.41 ( -19.43%)
BHmean-95 5-LPUSH          76348.83 (   0.00%)    56775.17 ( -25.64%)
BHmean-95 5-LPOP           75829.39 (   0.00%)    66104.77 ( -12.82%)
BHmean-95 5-SADD           71658.90 (   0.00%)    63011.97 ( -12.07%)
BHmean-95 5-SPOP           75357.95 (   0.00%)    63231.11 ( -16.09%)
BHmean-95 5-LRANGE_100     50075.12 (   0.00%)    31809.15 ( -36.48%)
BHmean-95 5-LRANGE_300     26897.99 (   0.00%)    17633.57 ( -34.44%)
BHmean-95 5-LRANGE_500     20288.09 (   0.00%)    14387.97 ( -29.08%)
BHmean-95 5-LRANGE_600     17096.94 (   0.00%)    11413.57 ( -33.24%)
BHmean-95 5-MSET-10        65178.43 (   0.00%)    45563.28 ( -30.09%)
BHmean-95 7-PING_INLINE    75528.70 (   0.00%)    62735.26 ( -16.94%)
BHmean-95 7-PING_BULK      78817.73 (   0.00%)    65316.79 ( -17.13%)
BHmean-95 7-SET            76467.21 (   0.00%)    60159.42 ( -21.33%)
BHmean-95 7-GET            85233.33 (   0.00%)    60679.61 ( -28.81%)
BHmean-95 7-INCR           78354.55 (   0.00%)    60523.53 ( -22.76%)
BHmean-95 7-LPUSH          77626.36 (   0.00%)    62098.94 ( -20.00%)
BHmean-95 7-LPOP           77101.00 (   0.00%)    61087.35 ( -20.77%)
BHmean-95 7-SADD           79649.54 (   0.00%)    62421.97 ( -21.63%)
BHmean-95 7-SPOP           81799.59 (   0.00%)    70584.08 ( -13.71%)
BHmean-95 7-LRANGE_100     49327.91 (   0.00%)    41950.71 ( -14.96%)
BHmean-95 7-LRANGE_300     25743.34 (   0.00%)    17583.96 ( -31.70%)
BHmean-95 7-LRANGE_500     20420.67 (   0.00%)    12366.67 ( -39.44%)
BHmean-95 7-LRANGE_600     16820.86 (   0.00%)    10474.77 ( -37.73%)
BHmean-95 7-MSET-10        64526.54 (   0.00%)    50806.55 ( -21.26%)
BHmean-95 8-PING_INLINE    75187.97 (   0.00%)    60141.33 ( -20.01%)
BHmean-95 8-PING_BULK      78079.25 (   0.00%)    62992.12 ( -19.32%)
BHmean-95 8-SET            80080.08 (   0.00%)    59040.59 ( -26.27%)
BHmean-95 8-GET            81037.28 (   0.00%)    63775.51 ( -21.30%)
BHmean-95 8-INCR           75272.86 (   0.00%)    65767.84 ( -12.63%)
BHmean-95 8-LPUSH          79477.22 (   0.00%)    66074.44 ( -16.86%)
BHmean-95 8-LPOP           75485.94 (   0.00%)    65231.57 ( -13.58%)
BHmean-95 8-SADD           76908.29 (   0.00%)    59514.95 ( -22.62%)
BHmean-95 8-SPOP           83804.74 (   0.00%)    60295.45 ( -28.05%)
BHmean-95 8-LRANGE_100     45253.98 (   0.00%)    41262.64 (  -8.82%)
BHmean-95 8-LRANGE_300     23930.60 (   0.00%)    16881.20 ( -29.46%)
BHmean-95 8-LRANGE_500     17487.87 (   0.00%)    14352.35 ( -17.93%)
BHmean-95 8-LRANGE_600     14299.50 (   0.00%)    10096.68 ( -29.39%)
BHmean-95 8-MSET-10        62823.93 (   0.00%)    50479.56 ( -19.65%)
BHmean-99 1-PING_INLINE    35993.88 (   0.00%)    25270.07 ( -29.79%)
BHmean-99 1-PING_BULK      38895.37 (   0.00%)    27750.80 ( -28.65%)
BHmean-99 1-SET            35137.04 (   0.00%)    26521.69 ( -24.52%)
BHmean-99 1-GET            36238.45 (   0.00%)    27372.89 ( -24.46%)
BHmean-99 1-INCR           36774.85 (   0.00%)    26467.28 ( -28.03%)
BHmean-99 1-LPUSH          37333.55 (   0.00%)    28740.22 ( -23.02%)
BHmean-99 1-LPOP           37739.41 (   0.00%)    27695.08 ( -26.61%)
BHmean-99 1-SADD           35492.46 (   0.00%)    28939.37 ( -18.46%)
BHmean-99 1-SPOP           37102.31 (   0.00%)    29214.14 ( -21.26%)
BHmean-99 1-LRANGE_100     29201.35 (   0.00%)    20012.01 ( -31.47%)
BHmean-99 1-LRANGE_300     18216.60 (   0.00%)    10854.82 ( -40.41%)
BHmean-99 1-LRANGE_500     14820.30 (   0.00%)     8511.36 ( -42.57%)
BHmean-99 1-LRANGE_600     12708.50 (   0.00%)     6770.94 ( -46.72%)
BHmean-99 1-MSET-10        30335.20 (   0.00%)    23702.30 ( -21.87%)
BHmean-99 3-PING_INLINE    72714.06 (   0.00%)    57061.34 ( -21.53%)
BHmean-99 3-PING_BULK      74515.65 (   0.00%)    57895.50 ( -22.30%)
BHmean-99 3-SET            78585.46 (   0.00%)    60957.03 ( -22.43%)
BHmean-99 3-GET            78678.21 (   0.00%)    65274.16 ( -17.04%)
BHmean-99 3-INCR           74404.76 (   0.00%)    68941.74 (  -7.34%)
BHmean-99 3-LPUSH          71816.15 (   0.00%)    59128.84 ( -17.67%)
BHmean-99 3-LPOP           69601.53 (   0.00%)    57249.18 ( -17.75%)
BHmean-99 3-SADD           66390.04 (   0.00%)    61050.06 (  -8.04%)
BHmean-99 3-SPOP           72912.87 (   0.00%)    56939.51 ( -21.91%)
BHmean-99 3-LRANGE_100     45372.05 (   0.00%)    35682.43 ( -21.36%)
BHmean-99 3-LRANGE_300     25070.51 (   0.00%)    20756.57 ( -17.21%)
BHmean-99 3-LRANGE_500     18990.65 (   0.00%)    13806.91 ( -27.30%)
BHmean-99 3-LRANGE_600     16237.06 (   0.00%)    12192.89 ( -24.91%)
BHmean-99 3-MSET-10        59853.36 (   0.00%)    43739.75 ( -26.92%)
BHmean-99 5-PING_INLINE    76074.55 (   0.00%)    59970.02 ( -21.17%)
BHmean-99 5-PING_BULK      79459.67 (   0.00%)    60661.21 ( -23.66%)
BHmean-99 5-SET            75714.56 (   0.00%)    60569.35 ( -20.00%)
BHmean-99 5-GET            80580.18 (   0.00%)    63471.91 ( -21.23%)
BHmean-99 5-INCR           77715.17 (   0.00%)    62617.41 ( -19.43%)
BHmean-99 5-LPUSH          76348.83 (   0.00%)    56775.17 ( -25.64%)
BHmean-99 5-LPOP           75829.39 (   0.00%)    66104.77 ( -12.82%)
BHmean-99 5-SADD           71658.90 (   0.00%)    63011.97 ( -12.07%)
BHmean-99 5-SPOP           75357.95 (   0.00%)    63231.11 ( -16.09%)
BHmean-99 5-LRANGE_100     50075.12 (   0.00%)    31809.15 ( -36.48%)
BHmean-99 5-LRANGE_300     26897.99 (   0.00%)    17633.57 ( -34.44%)
BHmean-99 5-LRANGE_500     20288.09 (   0.00%)    14387.97 ( -29.08%)
BHmean-99 5-LRANGE_600     17096.94 (   0.00%)    11413.57 ( -33.24%)
BHmean-99 5-MSET-10        65178.43 (   0.00%)    45563.28 ( -30.09%)
BHmean-99 7-PING_INLINE    75528.70 (   0.00%)    62735.26 ( -16.94%)
BHmean-99 7-PING_BULK      78817.73 (   0.00%)    65316.79 ( -17.13%)
BHmean-99 7-SET            76467.21 (   0.00%)    60159.42 ( -21.33%)
BHmean-99 7-GET            85233.33 (   0.00%)    60679.61 ( -28.81%)
BHmean-99 7-INCR           78354.55 (   0.00%)    60523.53 ( -22.76%)
BHmean-99 7-LPUSH          77626.36 (   0.00%)    62098.94 ( -20.00%)
BHmean-99 7-LPOP           77101.00 (   0.00%)    61087.35 ( -20.77%)
BHmean-99 7-SADD           79649.54 (   0.00%)    62421.97 ( -21.63%)
BHmean-99 7-SPOP           81799.59 (   0.00%)    70584.08 ( -13.71%)
BHmean-99 7-LRANGE_100     49327.91 (   0.00%)    41950.71 ( -14.96%)
BHmean-99 7-LRANGE_300     25743.34 (   0.00%)    17583.96 ( -31.70%)
BHmean-99 7-LRANGE_500     20420.67 (   0.00%)    12366.67 ( -39.44%)
BHmean-99 7-LRANGE_600     16820.86 (   0.00%)    10474.77 ( -37.73%)
BHmean-99 7-MSET-10        64526.54 (   0.00%)    50806.55 ( -21.26%)
BHmean-99 8-PING_INLINE    75187.97 (   0.00%)    60141.33 ( -20.01%)
BHmean-99 8-PING_BULK      78079.25 (   0.00%)    62992.12 ( -19.32%)
BHmean-99 8-SET            80080.08 (   0.00%)    59040.59 ( -26.27%)
BHmean-99 8-GET            81037.28 (   0.00%)    63775.51 ( -21.30%)
BHmean-99 8-INCR           75272.86 (   0.00%)    65767.84 ( -12.63%)
BHmean-99 8-LPUSH          79477.22 (   0.00%)    66074.44 ( -16.86%)
BHmean-99 8-LPOP           75485.94 (   0.00%)    65231.57 ( -13.58%)
BHmean-99 8-SADD           76908.29 (   0.00%)    59514.95 ( -22.62%)
BHmean-99 8-SPOP           83804.74 (   0.00%)    60295.45 ( -28.05%)
BHmean-99 8-LRANGE_100     45253.98 (   0.00%)    41262.64 (  -8.82%)
BHmean-99 8-LRANGE_300     23930.60 (   0.00%)    16881.20 ( -29.46%)
BHmean-99 8-LRANGE_500     17487.87 (   0.00%)    14352.35 ( -17.93%)
BHmean-99 8-LRANGE_600     14299.50 (   0.00%)    10096.68 ( -29.39%)
BHmean-99 8-MSET-10        62823.93 (   0.00%)    50479.56 ( -19.65%)

                    BASELINE        BUSY
Duration User         632.09      934.45
Duration System       762.86     1019.59
Duration Elapsed      975.82     1353.28

                                       BASELINE           BUSY
Ops Minor Faults                     5884093.00     2325847.00
Ops Major Faults                         419.00         118.00
Ops Swap Ins                             195.00          49.00
Ops Swap Outs                            271.00        9045.00
Ops Allocation stalls                      7.00           3.00
Ops Fragmentation stalls                   0.00           0.00
Ops DMA allocs                          8338.00        6788.00
Ops DMA32 allocs                     7846643.00     7524655.00
Ops Normal allocs                          0.00           0.00
Ops Movable allocs                         0.00           0.00
Ops Direct pages scanned                 348.00         119.00
Ops Kswapd pages scanned               85349.00       76044.00
Ops Kswapd pages reclaimed             72699.00       32093.00
Ops Direct pages reclaimed               226.00          69.00
Ops Kswapd efficiency %                   85.18          42.20
Ops Kswapd velocity                       87.46          56.19
Ops Direct efficiency %                   64.94          57.98
Ops Direct velocity                        0.36           0.09
Ops Percentage direct scans                0.41           0.16
Ops Page writes by reclaim               271.00        9045.00
Ops Page writes file                       0.00           0.00
Ops Page writes anon                     271.00        9045.00
Ops Page reclaim immediate                 4.00           0.00
Ops Sector Reads                      421072.00       74212.00
Ops Sector Writes                     256452.00      279588.00
Ops Page rescued immediate                 0.00           0.00
Ops Slabs scanned                      13654.00       21863.00
Ops Direct inode steals                   23.00           2.00
Ops Kswapd inode steals                 1265.00         246.00
Ops Kswapd skipped wait                    0.00           0.00
Ops THP fault alloc                      340.00         390.00
Ops THP fault fallback                    41.00          70.00
Ops THP collapse alloc                    34.00          14.00
Ops THP collapse fail                      6.00           3.00
Ops THP split                              0.00           3.00
Ops THP split failed                       0.00           0.00
Ops Compaction stalls                     16.00           6.00
Ops Compaction success                     2.00           0.00
Ops Compaction failures                   14.00           6.00
Ops Compaction efficiency                 12.50           0.00
Ops Page migrate success               80850.00       61020.00
Ops Page migrate failure               19162.00       31366.00
Ops Compaction pages isolated         183702.00      157849.00
Ops Compaction migrate scanned        416608.00      747050.00
Ops Compaction free scanned          1088889.00     2286265.00
Ops Compact scan efficiency               38.26          32.68
Ops Compaction cost                       90.60          72.01
Ops Kcompactd wake                       114.00           2.00
Ops Kcompactd migrate scanned          99537.00           0.00
Ops Kcompactd free scanned            242562.00           0.00
Ops NUMA alloc hit                   2447987.00     2297061.00
Ops NUMA alloc miss                        0.00           0.00
Ops NUMA interleave hit                    0.00           0.00
Ops NUMA alloc local                 2447987.00     2297061.00
Ops NUMA base-page range updates           0.00           0.00
Ops NUMA PTE updates                       0.00           0.00
Ops NUMA PMD updates                       0.00           0.00
Ops NUMA hint faults                       0.00           0.00
Ops NUMA hint local faults %               0.00           0.00
Ops NUMA hint local percent              100.00         100.00
Ops NUMA pages migrated                    0.00           0.00
Ops AutoNUMA cost                          0.00           0.00
```

### HTML Reporting with `compare-kernels.sh`

`compare-kernels.sh` can generate and HTML report, with tables but also
with graphs. This is how it is done:

```
cd work/log
../../compare-kernels.sh --format html --output-dir /tmp/html > /tmp/html/index.html
```

To view the report, just open the HTML page with a browser, e.g.:

```
firefox /tmp/html/index.html
```
